	// verilator_coverage annotation
	// generated by verigenSV.pl on Fri Jun  4 11:18:59 2021
	// input file: mesi.cfg
	
	// compiler directives
	/* verilator lint_off CASEINCOMPLETE */
	/* verilator lint_off DECLFILENAME */
	/* verilator lint_off UNUSED */
	/* verilator lint_off STMTDLY */
	/* verilator lint_off UNOPTFLAT */
	
	
	module MESI (
 000201		input logic clk,
%000004		input logic res_n,
%000026		input logic [31:0] addr,
 000020		input logic cp,
 000020		input logic rd,
 000021		input logic wr,
 000035		output logic [3:0] mesi, 
%000009		output logic [5:0] index, 
 000011		output logic err );
	
	  //
	 // parameter constants 
	//---------------------------
	parameter ZERO = 1'b0;
	parameter ONE = 1'b1;
	parameter ZERO_MESI = 4'b0000;
	parameter ZERO_TAG = 24'h000000;
	parameter ZERO_ADDR = 6'b000000;
	parameter MODIFIED = 4'b1000;
	parameter EXCLUSIVE = 4'b0100;
	parameter SHARED = 4'b0010;
	parameter INVALID = 4'b0001;
	
	
	  //
	 // state encoding typedef 
	//--------------------------------
	typedef enum logic [2:0] {
		ID = 3'b000,
		RD = 3'b001,
		WR = 3'b010,
		rRD = 3'b101,
		rWR = 3'b110
	} states_t;
	
	
	// internal state variables
 000052	states_t STATE, NEXT_STATE;
 000052	verilator_coverage: (next point on previous line)

	
	  //
	 // memory instantiations 
	//---------------------------
	RAM #( 4, 64 ) MESI_RAM(
		.clk(clk), .res_n(res_n), 
		.wr(MESI_RAM_wr), .wr_addr(MESI_RAM_wr_addr[5:0]), .wr_data(MESI_RAM_wr_data[3:0]), 
		.rd(MESI_RAM_rd), .rd_addr(MESI_RAM_rd_addr[5:0]), .rd_data(MESI_RAM_rd_data[3:0]) );
	
	RAM #( 24, 64 ) TAG_RAM(
		.clk(clk), .res_n(res_n), 
		.wr(TAG_RAM_wr), .wr_addr(TAG_RAM_wr_addr[5:0]), .wr_data(TAG_RAM_wr_data[23:0]), 
		.rd(TAG_RAM_rd), .rd_addr(TAG_RAM_rd_addr[5:0]), .rd_data(TAG_RAM_rd_data[23:0]) );
	
	   //
	  // implicit continuous assignments 
	 // (derived from <expressions> section) 
	//----------------------------------
 000039	uwire IDLE; assign IDLE = ~res_n | (~rd & ~wr);
%000008	uwire IS_EXCLUSIVE; assign IS_EXCLUSIVE = POP_MESI_RAM(MESI_READ,addr[7:2])==EXCLUSIVE;
%000008	uwire IS_INVALID; assign IS_INVALID = POP_MESI_RAM(MESI_READ,addr[7:2])==INVALID;
%000008	uwire IS_MODIFIED; assign IS_MODIFIED = POP_MESI_RAM(MESI_READ,addr[7:2])==MODIFIED;
%000003	uwire IS_SHARED; assign IS_SHARED = POP_MESI_RAM(MESI_READ,addr[7:2])==SHARED;
 000026	uwire MESI_READ; assign MESI_READ = WRITE | (TAG_MATCH & (rREAD | rWRITE));
 000035	uwire MESI_WRITE; assign MESI_WRITE = READ | WRITE | (TAG_MATCH & (rREAD | rWRITE));
%000009	uwire READ; assign READ = res_n & cp & rd;
 000030	uwire TAG_MATCH; assign TAG_MATCH = POP_TAG_RAM(TAG_READ,addr[7:2])==addr[31:8];
 000038	uwire TAG_READ; assign TAG_READ = READ | WRITE | rREAD | rWRITE;
%000008	uwire TAG_WRITE; assign TAG_WRITE = !TAG_MATCH & READ;
 000010	uwire WRITE; assign WRITE = res_n & cp & wr;
 000011	uwire rREAD; assign rREAD = res_n & ~cp & rd;
 000010	uwire rWRITE; assign rWRITE = res_n & ~cp & wr;
	
	  //
	 // initials for simulator
	//---------------------------
%000002	initial begin
%000001	  STATE = ID;
	
	  // dump output (Verilator)
%000002	  if ($test$plusargs("trace") != 0) begin
%000000	  verilator_coverage: (next point on previous line)

%000001	    $display("[%0t] Tracing to logs/vlt_dump.vcd...\n", $time);
%000001	    $dumpfile("logs/vlt_dump.vcd");
%000001	    $dumpvars();
	  end
%000001	  $display("[%0t] Model running...\n", $time);
	
	end
	
	  //
	 // state transfer
	//---------------------------
 000200	always_ff @( posedge clk ) begin
 000196	  if( res_n )
%000002	  verilator_coverage: (next point on previous line)

 000098	    STATE <= NEXT_STATE;
	  else
%000002	    STATE <= ID;
	
	  // condition for $finish (Verilator)
%000002	  if( rd==1'b1 && wr==1'b1 ) begin
 000099	  verilator_coverage: (next point on previous line)

%000001	    $write("*-* All Finished *-*\n");
%000001	    $finish;
	  end   
	
	end
	
	// AssertionExample:
	//always_ff @ (posedge clk) begin
	//   AssertionExample: assert (rd==1'b1 ^ wr==1'b1);
	//end
	
	// coverage analysis (Verilator)
%000002	cover property (@(posedge clk) rd==1'b1 && wr==1'b1);
	
 000486	always_comb begin
	
	    //
	   // pre-case (default) assignments 
	  //----------------------------------
 000243	  err = ZERO;
 000243	  index = addr[7:2];
 000243	  mesi = ZERO_MESI;
 000243	  PUSH_MESI_RAM(1'b0,addr[7:2],ZERO_MESI);
 000243	  PUSH_TAG_RAM(1'b0,addr[7:2],addr[31:8]);
	
 000243	  unique case ( STATE )
 000388	  ID : begin
 000300		if ( IDLE ) begin
 000044		verilator_coverage: (next point on previous line)

 000150		  NEXT_STATE = ID;
		end
%000004		if ( READ & TAG_MATCH ) begin
 000192		verilator_coverage: (next point on previous line)

%000002		  NEXT_STATE = RD;
%000002		  PUSH_MESI_RAM(MESI_WRITE,addr[7:2],EXCLUSIVE);
%000002		  mesi=EXCLUSIVE;
		end
%000008		if ( READ & ~TAG_MATCH ) begin
 000190		verilator_coverage: (next point on previous line)

%000004		  NEXT_STATE = RD;
%000004		  PUSH_TAG_RAM(TAG_WRITE,addr[7:2],addr[31:8]);
%000004		  PUSH_MESI_RAM(MESI_WRITE,addr[7:2],EXCLUSIVE);
%000004		  mesi=EXCLUSIVE;
		end
%000010		if ( WRITE & TAG_MATCH ) begin
 000189		verilator_coverage: (next point on previous line)

%000005		  NEXT_STATE = WR;
%000005		  PUSH_MESI_RAM(MESI_WRITE,addr[7:2],MODIFIED);
%000005		  mesi=MODIFIED;
		end
%000010		if ( WRITE & ~TAG_MATCH ) begin
 000189		verilator_coverage: (next point on previous line)

%000005		  NEXT_STATE = WR;
%000005		  err=ONE;
		end
 000020		if ( rWRITE & TAG_MATCH ) begin
 000184		verilator_coverage: (next point on previous line)

 000010		  NEXT_STATE = rWR;
 000010		  PUSH_MESI_RAM(MESI_WRITE,addr[7:2],INVALID);
 000010		  mesi=INVALID;
		end
%000012		if ( rREAD & TAG_MATCH ) begin
 000188		verilator_coverage: (next point on previous line)

%000006		  NEXT_STATE = rRD;
%000006		  PUSH_MESI_RAM(MESI_WRITE,addr[7:2],SHARED);
%000006		  mesi=SHARED;
		end
%000014		if ( rREAD & ~TAG_MATCH ) begin
 000187		verilator_coverage: (next point on previous line)

%000007		  NEXT_STATE = ID;
		end
	  end // ID
 000020	  RD : begin
%000012		if ( IDLE ) begin
%000004		verilator_coverage: (next point on previous line)

%000006		  NEXT_STATE = ID;
		end
%000004		if ( READ & TAG_MATCH ) begin
%000008		verilator_coverage: (next point on previous line)

%000002		  NEXT_STATE = RD;
%000002		  PUSH_MESI_RAM(MESI_WRITE,addr[7:2],EXCLUSIVE);
%000002		  mesi=EXCLUSIVE;
		end
%000004		if ( READ & ~TAG_MATCH ) begin
%000008		verilator_coverage: (next point on previous line)

%000002		  NEXT_STATE = RD;
%000002		  PUSH_TAG_RAM(TAG_WRITE,addr[7:2],addr[31:8]);
%000002		  PUSH_MESI_RAM(MESI_WRITE,addr[7:2],EXCLUSIVE);
%000002		  mesi=EXCLUSIVE;
		end
	  end // RD
 000030	  WR : begin
 000020		if ( IDLE ) begin
%000005		verilator_coverage: (next point on previous line)

 000010		  NEXT_STATE = ID;
		end
%000010		if ( WRITE & TAG_MATCH ) begin
 000010		verilator_coverage: (next point on previous line)

%000005		  NEXT_STATE = WR;
%000005		  PUSH_MESI_RAM(MESI_WRITE,addr[7:2],MODIFIED);
%000005		  mesi=MODIFIED;
		end
%000000		if ( WRITE & ~TAG_MATCH ) begin
 000015		verilator_coverage: (next point on previous line)

%000000		  NEXT_STATE = ID;
%000000		  err=ONE;
		end
	  end // WR
%000018	  rRD : begin
%000012		if ( IDLE ) begin
%000003		verilator_coverage: (next point on previous line)

%000006		  NEXT_STATE = ID;
		end
%000006		if ( rREAD & TAG_MATCH ) begin
%000006		verilator_coverage: (next point on previous line)

%000003		  NEXT_STATE = rRD;
%000003		  PUSH_MESI_RAM(MESI_WRITE,addr[7:2],SHARED);
%000003		  mesi=SHARED;
		end
%000000		if ( rREAD & ~TAG_MATCH ) begin
%000009		verilator_coverage: (next point on previous line)

%000000		  NEXT_STATE = rRD;
%000000		  PUSH_TAG_RAM(TAG_WRITE,addr[7:2],addr[31:8]);
%000000		  PUSH_MESI_RAM(MESI_WRITE,addr[7:2],SHARED);
%000000		  mesi=SHARED;
		end
	  end // rRD
 000030	  rWR : begin
 000020		if ( IDLE ) begin
%000005		verilator_coverage: (next point on previous line)

 000010		  NEXT_STATE = ID;
		end
%000010		if ( rWRITE & TAG_MATCH ) begin
 000010		verilator_coverage: (next point on previous line)

%000005		  NEXT_STATE = rWR;
%000005		  PUSH_MESI_RAM(MESI_WRITE,addr[7:2],INVALID);
%000005		  mesi=INVALID;
		end
%000000		if ( rWRITE & ~TAG_MATCH ) begin
 000015		verilator_coverage: (next point on previous line)

%000000		  NEXT_STATE = rWR;
		end
	  end // rWR
	  endcase
	end // always_comb
	
	
	  //
	 // memory functions
	//---------------------------
 000026	logic MESI_RAM_rd;
 000032	logic [4-1:0] MESI_RAM_rd_data;
%000008	logic [$clog2(64)-1:0] MESI_RAM_rd_addr;
	
 001944	function automatic [4-1:0] POP_MESI_RAM( read, [$clog2(64)-1:0] read_addr);
 000972	   MESI_RAM_rd = read;
 000972	   MESI_RAM_rd_addr = read_addr;
 000972	   return MESI_RAM_rd_data;
	endfunction
	
 000035	logic MESI_RAM_wr;
 000037	logic [4-1:0] MESI_RAM_wr_data;
%000008	logic [$clog2(64)-1:0] MESI_RAM_wr_addr;
	
 000574	function automatic void PUSH_MESI_RAM( write, [$clog2(64)-1:0] write_addr, [4-1:0] write_data);
 000287	   MESI_RAM_wr = write;
 000287	   MESI_RAM_wr_addr = write_addr;
 000287	   MESI_RAM_wr_data = write_data;
	endfunction
	
%000000	function automatic void NOP_MESI_RAM( write, [$clog2(64)-1:0] write_addr, [4-1:0] write_data);
%000000	   MESI_RAM_rd = 0;
%000000	   MESI_RAM_wr = 0;
%000000	   MESI_RAM_wr_addr = '0;
%000000	   MESI_RAM_wr_data = '0;
	endfunction
	
 000039	logic TAG_RAM_rd;
 000090	logic [24-1:0] TAG_RAM_rd_data;
%000007	logic [$clog2(64)-1:0] TAG_RAM_rd_addr;
	
 000486	function automatic [24-1:0] POP_TAG_RAM( read, [$clog2(64)-1:0] read_addr);
 000243	   TAG_RAM_rd = read;
 000243	   TAG_RAM_rd_addr = read_addr;
 000243	   return TAG_RAM_rd_data;
	endfunction
	
%000009	logic TAG_RAM_wr;
%000011	logic [24-1:0] TAG_RAM_wr_data;
%000010	logic [$clog2(64)-1:0] TAG_RAM_wr_addr;
	
 000498	function automatic void PUSH_TAG_RAM( write, [$clog2(64)-1:0] write_addr, [24-1:0] write_data);
 000249	   TAG_RAM_wr = write;
 000249	   TAG_RAM_wr_addr = write_addr;
 000249	   TAG_RAM_wr_data = write_data;
	endfunction
	
%000000	function automatic void NOP_TAG_RAM( write, [$clog2(64)-1:0] write_addr, [24-1:0] write_data);
%000000	   TAG_RAM_rd = 0;
%000000	   TAG_RAM_wr = 0;
%000000	   TAG_RAM_wr_addr = '0;
%000000	   TAG_RAM_wr_data = '0;
	endfunction
	
	endmodule
	
	
	  //
	 // memory
	//---------------------------
	module RAM ( clk, res_n, wr, wr_addr, wr_data, rd, rd_addr, rd_data );
	
	parameter DATA_WIDTH = 32;
	parameter NUM_ENTRIES = 16;
	parameter ADDR_WIDTH = $clog2(NUM_ENTRIES);
	
 000402	input  uwire clk, res_n, rd, wr;
%000008	verilator_coverage: (next point on previous line)

 000065	verilator_coverage: (next point on previous line)

 000044	verilator_coverage: (next point on previous line)

 000048	input  uwire [DATA_WIDTH-1:0] wr_data;
%000015	input  uwire [ADDR_WIDTH-1:0] rd_addr, wr_addr;
%000018	verilator_coverage: (next point on previous line)

 000122	output uwire [DATA_WIDTH-1:0] rd_data;
	
	parameter ZERO_ADDR = {ADDR_WIDTH{1'b0}};
	parameter ZERO_DATA = {DATA_WIDTH{1'b0}};
	parameter ONE_DATA = {DATA_WIDTH{1'b1}};
	    
%000163	logic    [DATA_WIDTH-1:0] MEMORY [NUM_ENTRIES-1:0];
	
	integer i;
	
%000004	initial begin
	   // Clear RAM before simulation start
%000002	   for ( i = 0; i < NUM_ENTRIES; i = i + 1 ) begin
 000256	   verilator_coverage: (next point on previous line)

 000128	       MEMORY[ i ] = ZERO_DATA;
	   end
	end
	
	// IN-CYCLE READ ACCESS
	assign rd_data =  ( rd ) ? MEMORY[rd_addr] : 'Z;
	
 000400	always_ff @ ( negedge clk ) begin
	    // WRITE ACCESS
 000038	   if( wr ) MEMORY[wr_addr] <= wr_data;
 000181	   verilator_coverage: (next point on previous line)

	end
	
	endmodule
	
