// Verilated -*- C++ -*-
// DESCRIPTION: Verilator output: Design implementation internals
// See VMESI.h for the primary calling header

#include "VMESI.h"
#include "VMESI__Syms.h"

//==========

void VMESI::eval_step() {
    VL_DEBUG_IF(VL_DBG_MSGF("+++++TOP Evaluate VMESI::eval\n"); );
    VMESI__Syms* __restrict vlSymsp = this->__VlSymsp;  // Setup global symbol table
    VMESI* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
#ifdef VL_DEBUG
    // Debug assertions
    _eval_debug_assertions();
#endif  // VL_DEBUG
    // Initialize
    if (VL_UNLIKELY(!vlSymsp->__Vm_didInit)) _eval_initial_loop(vlSymsp);
    // Evaluate till stable
    int __VclockLoop = 0;
    QData __Vchange = 1;
    do {
        VL_DEBUG_IF(VL_DBG_MSGF("+ Clock loop\n"););
        vlSymsp->__Vm_activity = true;
        _eval(vlSymsp);
        if (VL_UNLIKELY(++__VclockLoop > 100)) {
            // About to fail, so enable debug to see what's not settling.
            // Note you must run make with OPT=-DVL_DEBUG for debug prints.
            int __Vsaved_debug = Verilated::debug();
            Verilated::debug(1);
            __Vchange = _change_request(vlSymsp);
            Verilated::debug(__Vsaved_debug);
            VL_FATAL_MT("MESI.sv", 11, "",
                "Verilated model didn't converge\n"
                "- See DIDNOTCONVERGE in the Verilator manual");
        } else {
            __Vchange = _change_request(vlSymsp);
        }
    } while (VL_UNLIKELY(__Vchange));
}

void VMESI::eval_end_step() {
    VL_DEBUG_IF(VL_DBG_MSGF("+eval_end_step VMESI::eval_end_step\n"); );
#ifdef VM_TRACE
    VMESI__Syms* __restrict vlSymsp = this->__VlSymsp;  // Setup global symbol table
    VMESI* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Tracing
    if (VL_UNLIKELY(vlSymsp->__Vm_dumping)) _traceDump();
#endif  // VM_TRACE
}

void VMESI::_eval_initial_loop(VMESI__Syms* __restrict vlSymsp) {
    vlSymsp->__Vm_didInit = true;
    _eval_initial(vlSymsp);
    vlSymsp->__Vm_activity = true;
    // Evaluate till stable
    int __VclockLoop = 0;
    QData __Vchange = 1;
    do {
        _eval_settle(vlSymsp);
        _eval(vlSymsp);
        if (VL_UNLIKELY(++__VclockLoop > 100)) {
            // About to fail, so enable debug to see what's not settling.
            // Note you must run make with OPT=-DVL_DEBUG for debug prints.
            int __Vsaved_debug = Verilated::debug();
            Verilated::debug(1);
            __Vchange = _change_request(vlSymsp);
            Verilated::debug(__Vsaved_debug);
            VL_FATAL_MT("MESI.sv", 11, "",
                "Verilated model didn't DC converge\n"
                "- See DIDNOTCONVERGE in the Verilator manual");
        } else {
            __Vchange = _change_request(vlSymsp);
        }
    } while (VL_UNLIKELY(__Vchange));
}

VL_INLINE_OPT void VMESI::_combo__TOP__1(VMESI__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_DBG_MSGF("+    VMESI::_combo__TOP__1\n"); );
    VMESI* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    if ((1U & ((IData)(vlTOPp->MESI__DOT__MESI_RAM_rd_data) 
               ^ vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_rd_data))) {
        ++(vlSymsp->__Vcoverage[74]);
        vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_rd_data 
            = ((0xeU & (IData)(vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_rd_data)) 
               | (1U & (IData)(vlTOPp->MESI__DOT__MESI_RAM_rd_data)));
    }
    if ((2U & ((IData)(vlTOPp->MESI__DOT__MESI_RAM_rd_data) 
               ^ vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_rd_data))) {
        ++(vlSymsp->__Vcoverage[75]);
        vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_rd_data 
            = ((0xdU & (IData)(vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_rd_data)) 
               | (2U & (IData)(vlTOPp->MESI__DOT__MESI_RAM_rd_data)));
    }
    if ((4U & ((IData)(vlTOPp->MESI__DOT__MESI_RAM_rd_data) 
               ^ vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_rd_data))) {
        ++(vlSymsp->__Vcoverage[76]);
        vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_rd_data 
            = ((0xbU & (IData)(vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_rd_data)) 
               | (4U & (IData)(vlTOPp->MESI__DOT__MESI_RAM_rd_data)));
    }
    if ((8U & ((IData)(vlTOPp->MESI__DOT__MESI_RAM_rd_data) 
               ^ vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_rd_data))) {
        ++(vlSymsp->__Vcoverage[77]);
        vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_rd_data 
            = ((7U & (IData)(vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_rd_data)) 
               | (8U & (IData)(vlTOPp->MESI__DOT__MESI_RAM_rd_data)));
    }
    if ((1U & (vlTOPp->MESI__DOT__TAG_RAM_rd_data ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data))) {
        ++(vlSymsp->__Vcoverage[116]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data 
            = ((0xfffffeU & vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data) 
               | (1U & vlTOPp->MESI__DOT__TAG_RAM_rd_data));
    }
    if ((2U & (vlTOPp->MESI__DOT__TAG_RAM_rd_data ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data))) {
        ++(vlSymsp->__Vcoverage[117]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data 
            = ((0xfffffdU & vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data) 
               | (2U & vlTOPp->MESI__DOT__TAG_RAM_rd_data));
    }
    if ((4U & (vlTOPp->MESI__DOT__TAG_RAM_rd_data ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data))) {
        ++(vlSymsp->__Vcoverage[118]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data 
            = ((0xfffffbU & vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data) 
               | (4U & vlTOPp->MESI__DOT__TAG_RAM_rd_data));
    }
    if ((8U & (vlTOPp->MESI__DOT__TAG_RAM_rd_data ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data))) {
        ++(vlSymsp->__Vcoverage[119]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data 
            = ((0xfffff7U & vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data) 
               | (8U & vlTOPp->MESI__DOT__TAG_RAM_rd_data));
    }
    if ((0x10U & (vlTOPp->MESI__DOT__TAG_RAM_rd_data 
                  ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data))) {
        ++(vlSymsp->__Vcoverage[120]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data 
            = ((0xffffefU & vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data) 
               | (0x10U & vlTOPp->MESI__DOT__TAG_RAM_rd_data));
    }
    if ((0x20U & (vlTOPp->MESI__DOT__TAG_RAM_rd_data 
                  ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data))) {
        ++(vlSymsp->__Vcoverage[121]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data 
            = ((0xffffdfU & vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data) 
               | (0x20U & vlTOPp->MESI__DOT__TAG_RAM_rd_data));
    }
    if ((0x40U & (vlTOPp->MESI__DOT__TAG_RAM_rd_data 
                  ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data))) {
        ++(vlSymsp->__Vcoverage[122]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data 
            = ((0xffffbfU & vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data) 
               | (0x40U & vlTOPp->MESI__DOT__TAG_RAM_rd_data));
    }
    if ((0x80U & (vlTOPp->MESI__DOT__TAG_RAM_rd_data 
                  ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data))) {
        ++(vlSymsp->__Vcoverage[123]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data 
            = ((0xffff7fU & vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data) 
               | (0x80U & vlTOPp->MESI__DOT__TAG_RAM_rd_data));
    }
    if ((0x100U & (vlTOPp->MESI__DOT__TAG_RAM_rd_data 
                   ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data))) {
        ++(vlSymsp->__Vcoverage[124]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data 
            = ((0xfffeffU & vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data) 
               | (0x100U & vlTOPp->MESI__DOT__TAG_RAM_rd_data));
    }
    if ((0x200U & (vlTOPp->MESI__DOT__TAG_RAM_rd_data 
                   ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data))) {
        ++(vlSymsp->__Vcoverage[125]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data 
            = ((0xfffdffU & vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data) 
               | (0x200U & vlTOPp->MESI__DOT__TAG_RAM_rd_data));
    }
    if ((0x400U & (vlTOPp->MESI__DOT__TAG_RAM_rd_data 
                   ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data))) {
        ++(vlSymsp->__Vcoverage[126]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data 
            = ((0xfffbffU & vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data) 
               | (0x400U & vlTOPp->MESI__DOT__TAG_RAM_rd_data));
    }
    if ((0x800U & (vlTOPp->MESI__DOT__TAG_RAM_rd_data 
                   ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data))) {
        ++(vlSymsp->__Vcoverage[127]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data 
            = ((0xfff7ffU & vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data) 
               | (0x800U & vlTOPp->MESI__DOT__TAG_RAM_rd_data));
    }
    if ((0x1000U & (vlTOPp->MESI__DOT__TAG_RAM_rd_data 
                    ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data))) {
        ++(vlSymsp->__Vcoverage[128]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data 
            = ((0xffefffU & vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data) 
               | (0x1000U & vlTOPp->MESI__DOT__TAG_RAM_rd_data));
    }
    if ((0x2000U & (vlTOPp->MESI__DOT__TAG_RAM_rd_data 
                    ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data))) {
        ++(vlSymsp->__Vcoverage[129]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data 
            = ((0xffdfffU & vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data) 
               | (0x2000U & vlTOPp->MESI__DOT__TAG_RAM_rd_data));
    }
    if ((0x4000U & (vlTOPp->MESI__DOT__TAG_RAM_rd_data 
                    ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data))) {
        ++(vlSymsp->__Vcoverage[130]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data 
            = ((0xffbfffU & vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data) 
               | (0x4000U & vlTOPp->MESI__DOT__TAG_RAM_rd_data));
    }
    if ((0x8000U & (vlTOPp->MESI__DOT__TAG_RAM_rd_data 
                    ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data))) {
        ++(vlSymsp->__Vcoverage[131]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data 
            = ((0xff7fffU & vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data) 
               | (0x8000U & vlTOPp->MESI__DOT__TAG_RAM_rd_data));
    }
    if ((0x10000U & (vlTOPp->MESI__DOT__TAG_RAM_rd_data 
                     ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data))) {
        ++(vlSymsp->__Vcoverage[132]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data 
            = ((0xfeffffU & vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data) 
               | (0x10000U & vlTOPp->MESI__DOT__TAG_RAM_rd_data));
    }
    if ((0x20000U & (vlTOPp->MESI__DOT__TAG_RAM_rd_data 
                     ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data))) {
        ++(vlSymsp->__Vcoverage[133]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data 
            = ((0xfdffffU & vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data) 
               | (0x20000U & vlTOPp->MESI__DOT__TAG_RAM_rd_data));
    }
    if ((0x40000U & (vlTOPp->MESI__DOT__TAG_RAM_rd_data 
                     ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data))) {
        ++(vlSymsp->__Vcoverage[134]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data 
            = ((0xfbffffU & vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data) 
               | (0x40000U & vlTOPp->MESI__DOT__TAG_RAM_rd_data));
    }
    if ((0x80000U & (vlTOPp->MESI__DOT__TAG_RAM_rd_data 
                     ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data))) {
        ++(vlSymsp->__Vcoverage[135]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data 
            = ((0xf7ffffU & vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data) 
               | (0x80000U & vlTOPp->MESI__DOT__TAG_RAM_rd_data));
    }
    if ((0x100000U & (vlTOPp->MESI__DOT__TAG_RAM_rd_data 
                      ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data))) {
        ++(vlSymsp->__Vcoverage[136]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data 
            = ((0xefffffU & vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data) 
               | (0x100000U & vlTOPp->MESI__DOT__TAG_RAM_rd_data));
    }
    if ((0x200000U & (vlTOPp->MESI__DOT__TAG_RAM_rd_data 
                      ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data))) {
        ++(vlSymsp->__Vcoverage[137]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data 
            = ((0xdfffffU & vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data) 
               | (0x200000U & vlTOPp->MESI__DOT__TAG_RAM_rd_data));
    }
    if ((0x400000U & (vlTOPp->MESI__DOT__TAG_RAM_rd_data 
                      ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data))) {
        ++(vlSymsp->__Vcoverage[138]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data 
            = ((0xbfffffU & vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data) 
               | (0x400000U & vlTOPp->MESI__DOT__TAG_RAM_rd_data));
    }
    if ((0x800000U & (vlTOPp->MESI__DOT__TAG_RAM_rd_data 
                      ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data))) {
        ++(vlSymsp->__Vcoverage[139]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data 
            = ((0x7fffffU & vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_data) 
               | (0x800000U & vlTOPp->MESI__DOT__TAG_RAM_rd_data));
    }
    if (((IData)(vlTOPp->clk) ^ vlTOPp->MESI__DOT____Vtogcov__clk)) {
        ++(vlSymsp->__Vcoverage[0]);
        vlTOPp->MESI__DOT____Vtogcov__clk = vlTOPp->clk;
    }
    if (((IData)(vlTOPp->res_n) ^ vlTOPp->MESI__DOT____Vtogcov__res_n)) {
        ++(vlSymsp->__Vcoverage[1]);
        vlTOPp->MESI__DOT____Vtogcov__res_n = vlTOPp->res_n;
    }
    if (((IData)(vlTOPp->cp) ^ vlTOPp->MESI__DOT____Vtogcov__cp)) {
        ++(vlSymsp->__Vcoverage[34]);
        vlTOPp->MESI__DOT____Vtogcov__cp = vlTOPp->cp;
    }
    if (((IData)(vlTOPp->rd) ^ vlTOPp->MESI__DOT____Vtogcov__rd)) {
        ++(vlSymsp->__Vcoverage[35]);
        vlTOPp->MESI__DOT____Vtogcov__rd = vlTOPp->rd;
    }
    if (((IData)(vlTOPp->wr) ^ vlTOPp->MESI__DOT____Vtogcov__wr)) {
        ++(vlSymsp->__Vcoverage[36]);
        vlTOPp->MESI__DOT____Vtogcov__wr = vlTOPp->wr;
    }
    if ((1U & (vlTOPp->addr ^ vlTOPp->MESI__DOT____Vtogcov__addr))) {
        ++(vlSymsp->__Vcoverage[2]);
        vlTOPp->MESI__DOT____Vtogcov__addr = ((0xfffffffeU 
                                               & vlTOPp->MESI__DOT____Vtogcov__addr) 
                                              | (1U 
                                                 & vlTOPp->addr));
    }
    if ((2U & (vlTOPp->addr ^ vlTOPp->MESI__DOT____Vtogcov__addr))) {
        ++(vlSymsp->__Vcoverage[3]);
        vlTOPp->MESI__DOT____Vtogcov__addr = ((0xfffffffdU 
                                               & vlTOPp->MESI__DOT____Vtogcov__addr) 
                                              | (2U 
                                                 & vlTOPp->addr));
    }
    if ((4U & (vlTOPp->addr ^ vlTOPp->MESI__DOT____Vtogcov__addr))) {
        ++(vlSymsp->__Vcoverage[4]);
        vlTOPp->MESI__DOT____Vtogcov__addr = ((0xfffffffbU 
                                               & vlTOPp->MESI__DOT____Vtogcov__addr) 
                                              | (4U 
                                                 & vlTOPp->addr));
    }
    if ((8U & (vlTOPp->addr ^ vlTOPp->MESI__DOT____Vtogcov__addr))) {
        ++(vlSymsp->__Vcoverage[5]);
        vlTOPp->MESI__DOT____Vtogcov__addr = ((0xfffffff7U 
                                               & vlTOPp->MESI__DOT____Vtogcov__addr) 
                                              | (8U 
                                                 & vlTOPp->addr));
    }
    if ((0x10U & (vlTOPp->addr ^ vlTOPp->MESI__DOT____Vtogcov__addr))) {
        ++(vlSymsp->__Vcoverage[6]);
        vlTOPp->MESI__DOT____Vtogcov__addr = ((0xffffffefU 
                                               & vlTOPp->MESI__DOT____Vtogcov__addr) 
                                              | (0x10U 
                                                 & vlTOPp->addr));
    }
    if ((0x20U & (vlTOPp->addr ^ vlTOPp->MESI__DOT____Vtogcov__addr))) {
        ++(vlSymsp->__Vcoverage[7]);
        vlTOPp->MESI__DOT____Vtogcov__addr = ((0xffffffdfU 
                                               & vlTOPp->MESI__DOT____Vtogcov__addr) 
                                              | (0x20U 
                                                 & vlTOPp->addr));
    }
    if ((0x40U & (vlTOPp->addr ^ vlTOPp->MESI__DOT____Vtogcov__addr))) {
        ++(vlSymsp->__Vcoverage[8]);
        vlTOPp->MESI__DOT____Vtogcov__addr = ((0xffffffbfU 
                                               & vlTOPp->MESI__DOT____Vtogcov__addr) 
                                              | (0x40U 
                                                 & vlTOPp->addr));
    }
    if ((0x80U & (vlTOPp->addr ^ vlTOPp->MESI__DOT____Vtogcov__addr))) {
        ++(vlSymsp->__Vcoverage[9]);
        vlTOPp->MESI__DOT____Vtogcov__addr = ((0xffffff7fU 
                                               & vlTOPp->MESI__DOT____Vtogcov__addr) 
                                              | (0x80U 
                                                 & vlTOPp->addr));
    }
    if ((0x100U & (vlTOPp->addr ^ vlTOPp->MESI__DOT____Vtogcov__addr))) {
        ++(vlSymsp->__Vcoverage[10]);
        vlTOPp->MESI__DOT____Vtogcov__addr = ((0xfffffeffU 
                                               & vlTOPp->MESI__DOT____Vtogcov__addr) 
                                              | (0x100U 
                                                 & vlTOPp->addr));
    }
    if ((0x200U & (vlTOPp->addr ^ vlTOPp->MESI__DOT____Vtogcov__addr))) {
        ++(vlSymsp->__Vcoverage[11]);
        vlTOPp->MESI__DOT____Vtogcov__addr = ((0xfffffdffU 
                                               & vlTOPp->MESI__DOT____Vtogcov__addr) 
                                              | (0x200U 
                                                 & vlTOPp->addr));
    }
    if ((0x400U & (vlTOPp->addr ^ vlTOPp->MESI__DOT____Vtogcov__addr))) {
        ++(vlSymsp->__Vcoverage[12]);
        vlTOPp->MESI__DOT____Vtogcov__addr = ((0xfffffbffU 
                                               & vlTOPp->MESI__DOT____Vtogcov__addr) 
                                              | (0x400U 
                                                 & vlTOPp->addr));
    }
    if ((0x800U & (vlTOPp->addr ^ vlTOPp->MESI__DOT____Vtogcov__addr))) {
        ++(vlSymsp->__Vcoverage[13]);
        vlTOPp->MESI__DOT____Vtogcov__addr = ((0xfffff7ffU 
                                               & vlTOPp->MESI__DOT____Vtogcov__addr) 
                                              | (0x800U 
                                                 & vlTOPp->addr));
    }
    if ((0x1000U & (vlTOPp->addr ^ vlTOPp->MESI__DOT____Vtogcov__addr))) {
        ++(vlSymsp->__Vcoverage[14]);
        vlTOPp->MESI__DOT____Vtogcov__addr = ((0xffffefffU 
                                               & vlTOPp->MESI__DOT____Vtogcov__addr) 
                                              | (0x1000U 
                                                 & vlTOPp->addr));
    }
    if ((0x2000U & (vlTOPp->addr ^ vlTOPp->MESI__DOT____Vtogcov__addr))) {
        ++(vlSymsp->__Vcoverage[15]);
        vlTOPp->MESI__DOT____Vtogcov__addr = ((0xffffdfffU 
                                               & vlTOPp->MESI__DOT____Vtogcov__addr) 
                                              | (0x2000U 
                                                 & vlTOPp->addr));
    }
    if ((0x4000U & (vlTOPp->addr ^ vlTOPp->MESI__DOT____Vtogcov__addr))) {
        ++(vlSymsp->__Vcoverage[16]);
        vlTOPp->MESI__DOT____Vtogcov__addr = ((0xffffbfffU 
                                               & vlTOPp->MESI__DOT____Vtogcov__addr) 
                                              | (0x4000U 
                                                 & vlTOPp->addr));
    }
    if ((0x8000U & (vlTOPp->addr ^ vlTOPp->MESI__DOT____Vtogcov__addr))) {
        ++(vlSymsp->__Vcoverage[17]);
        vlTOPp->MESI__DOT____Vtogcov__addr = ((0xffff7fffU 
                                               & vlTOPp->MESI__DOT____Vtogcov__addr) 
                                              | (0x8000U 
                                                 & vlTOPp->addr));
    }
    if ((0x10000U & (vlTOPp->addr ^ vlTOPp->MESI__DOT____Vtogcov__addr))) {
        ++(vlSymsp->__Vcoverage[18]);
        vlTOPp->MESI__DOT____Vtogcov__addr = ((0xfffeffffU 
                                               & vlTOPp->MESI__DOT____Vtogcov__addr) 
                                              | (0x10000U 
                                                 & vlTOPp->addr));
    }
    if ((0x20000U & (vlTOPp->addr ^ vlTOPp->MESI__DOT____Vtogcov__addr))) {
        ++(vlSymsp->__Vcoverage[19]);
        vlTOPp->MESI__DOT____Vtogcov__addr = ((0xfffdffffU 
                                               & vlTOPp->MESI__DOT____Vtogcov__addr) 
                                              | (0x20000U 
                                                 & vlTOPp->addr));
    }
    if ((0x40000U & (vlTOPp->addr ^ vlTOPp->MESI__DOT____Vtogcov__addr))) {
        ++(vlSymsp->__Vcoverage[20]);
        vlTOPp->MESI__DOT____Vtogcov__addr = ((0xfffbffffU 
                                               & vlTOPp->MESI__DOT____Vtogcov__addr) 
                                              | (0x40000U 
                                                 & vlTOPp->addr));
    }
    if ((0x80000U & (vlTOPp->addr ^ vlTOPp->MESI__DOT____Vtogcov__addr))) {
        ++(vlSymsp->__Vcoverage[21]);
        vlTOPp->MESI__DOT____Vtogcov__addr = ((0xfff7ffffU 
                                               & vlTOPp->MESI__DOT____Vtogcov__addr) 
                                              | (0x80000U 
                                                 & vlTOPp->addr));
    }
    if ((0x100000U & (vlTOPp->addr ^ vlTOPp->MESI__DOT____Vtogcov__addr))) {
        ++(vlSymsp->__Vcoverage[22]);
        vlTOPp->MESI__DOT____Vtogcov__addr = ((0xffefffffU 
                                               & vlTOPp->MESI__DOT____Vtogcov__addr) 
                                              | (0x100000U 
                                                 & vlTOPp->addr));
    }
    if ((0x200000U & (vlTOPp->addr ^ vlTOPp->MESI__DOT____Vtogcov__addr))) {
        ++(vlSymsp->__Vcoverage[23]);
        vlTOPp->MESI__DOT____Vtogcov__addr = ((0xffdfffffU 
                                               & vlTOPp->MESI__DOT____Vtogcov__addr) 
                                              | (0x200000U 
                                                 & vlTOPp->addr));
    }
    if ((0x400000U & (vlTOPp->addr ^ vlTOPp->MESI__DOT____Vtogcov__addr))) {
        ++(vlSymsp->__Vcoverage[24]);
        vlTOPp->MESI__DOT____Vtogcov__addr = ((0xffbfffffU 
                                               & vlTOPp->MESI__DOT____Vtogcov__addr) 
                                              | (0x400000U 
                                                 & vlTOPp->addr));
    }
    if ((0x800000U & (vlTOPp->addr ^ vlTOPp->MESI__DOT____Vtogcov__addr))) {
        ++(vlSymsp->__Vcoverage[25]);
        vlTOPp->MESI__DOT____Vtogcov__addr = ((0xff7fffffU 
                                               & vlTOPp->MESI__DOT____Vtogcov__addr) 
                                              | (0x800000U 
                                                 & vlTOPp->addr));
    }
    if ((0x1000000U & (vlTOPp->addr ^ vlTOPp->MESI__DOT____Vtogcov__addr))) {
        ++(vlSymsp->__Vcoverage[26]);
        vlTOPp->MESI__DOT____Vtogcov__addr = ((0xfeffffffU 
                                               & vlTOPp->MESI__DOT____Vtogcov__addr) 
                                              | (0x1000000U 
                                                 & vlTOPp->addr));
    }
    if ((0x2000000U & (vlTOPp->addr ^ vlTOPp->MESI__DOT____Vtogcov__addr))) {
        ++(vlSymsp->__Vcoverage[27]);
        vlTOPp->MESI__DOT____Vtogcov__addr = ((0xfdffffffU 
                                               & vlTOPp->MESI__DOT____Vtogcov__addr) 
                                              | (0x2000000U 
                                                 & vlTOPp->addr));
    }
    if ((0x4000000U & (vlTOPp->addr ^ vlTOPp->MESI__DOT____Vtogcov__addr))) {
        ++(vlSymsp->__Vcoverage[28]);
        vlTOPp->MESI__DOT____Vtogcov__addr = ((0xfbffffffU 
                                               & vlTOPp->MESI__DOT____Vtogcov__addr) 
                                              | (0x4000000U 
                                                 & vlTOPp->addr));
    }
    if ((0x8000000U & (vlTOPp->addr ^ vlTOPp->MESI__DOT____Vtogcov__addr))) {
        ++(vlSymsp->__Vcoverage[29]);
        vlTOPp->MESI__DOT____Vtogcov__addr = ((0xf7ffffffU 
                                               & vlTOPp->MESI__DOT____Vtogcov__addr) 
                                              | (0x8000000U 
                                                 & vlTOPp->addr));
    }
    if ((0x10000000U & (vlTOPp->addr ^ vlTOPp->MESI__DOT____Vtogcov__addr))) {
        ++(vlSymsp->__Vcoverage[30]);
        vlTOPp->MESI__DOT____Vtogcov__addr = ((0xefffffffU 
                                               & vlTOPp->MESI__DOT____Vtogcov__addr) 
                                              | (0x10000000U 
                                                 & vlTOPp->addr));
    }
    if ((0x20000000U & (vlTOPp->addr ^ vlTOPp->MESI__DOT____Vtogcov__addr))) {
        ++(vlSymsp->__Vcoverage[31]);
        vlTOPp->MESI__DOT____Vtogcov__addr = ((0xdfffffffU 
                                               & vlTOPp->MESI__DOT____Vtogcov__addr) 
                                              | (0x20000000U 
                                                 & vlTOPp->addr));
    }
    if ((0x40000000U & (vlTOPp->addr ^ vlTOPp->MESI__DOT____Vtogcov__addr))) {
        ++(vlSymsp->__Vcoverage[32]);
        vlTOPp->MESI__DOT____Vtogcov__addr = ((0xbfffffffU 
                                               & vlTOPp->MESI__DOT____Vtogcov__addr) 
                                              | (0x40000000U 
                                                 & vlTOPp->addr));
    }
    if ((0x80000000U & (vlTOPp->addr ^ vlTOPp->MESI__DOT____Vtogcov__addr))) {
        ++(vlSymsp->__Vcoverage[33]);
        vlTOPp->MESI__DOT____Vtogcov__addr = ((0x7fffffffU 
                                               & vlTOPp->MESI__DOT____Vtogcov__addr) 
                                              | (0x80000000U 
                                                 & vlTOPp->addr));
    }
    vlTOPp->MESI__DOT__IDLE = (1U & ((~ (IData)(vlTOPp->res_n)) 
                                     | ((~ (IData)(vlTOPp->rd)) 
                                        & (~ (IData)(vlTOPp->wr)))));
    vlTOPp->MESI__DOT__WRITE = (((IData)(vlTOPp->res_n) 
                                 & (IData)(vlTOPp->cp)) 
                                & (IData)(vlTOPp->wr));
    vlTOPp->MESI__DOT__rREAD = (((IData)(vlTOPp->res_n) 
                                 & (~ (IData)(vlTOPp->cp))) 
                                & (IData)(vlTOPp->rd));
    vlTOPp->MESI__DOT__rWRITE = (((IData)(vlTOPp->res_n) 
                                  & (~ (IData)(vlTOPp->cp))) 
                                 & (IData)(vlTOPp->wr));
    vlTOPp->MESI__DOT__READ = (((IData)(vlTOPp->res_n) 
                                & (IData)(vlTOPp->cp)) 
                               & (IData)(vlTOPp->rd));
    if (((IData)(vlTOPp->MESI__DOT__IDLE) ^ vlTOPp->MESI__DOT____Vtogcov__IDLE)) {
        ++(vlSymsp->__Vcoverage[140]);
        vlTOPp->MESI__DOT____Vtogcov__IDLE = vlTOPp->MESI__DOT__IDLE;
    }
    if (((IData)(vlTOPp->MESI__DOT__WRITE) ^ vlTOPp->MESI__DOT____Vtogcov__WRITE)) {
        ++(vlSymsp->__Vcoverage[151]);
        vlTOPp->MESI__DOT____Vtogcov__WRITE = vlTOPp->MESI__DOT__WRITE;
    }
    if (((IData)(vlTOPp->MESI__DOT__rREAD) ^ vlTOPp->MESI__DOT____Vtogcov__rREAD)) {
        ++(vlSymsp->__Vcoverage[152]);
        vlTOPp->MESI__DOT____Vtogcov__rREAD = vlTOPp->MESI__DOT__rREAD;
    }
    if (((IData)(vlTOPp->MESI__DOT__rWRITE) ^ vlTOPp->MESI__DOT____Vtogcov__rWRITE)) {
        ++(vlSymsp->__Vcoverage[153]);
        vlTOPp->MESI__DOT____Vtogcov__rWRITE = vlTOPp->MESI__DOT__rWRITE;
    }
    if (((IData)(vlTOPp->MESI__DOT__READ) ^ vlTOPp->MESI__DOT____Vtogcov__READ)) {
        ++(vlSymsp->__Vcoverage[147]);
        vlTOPp->MESI__DOT____Vtogcov__READ = vlTOPp->MESI__DOT__READ;
    }
    vlTOPp->MESI__DOT__TAG_READ = ((((IData)(vlTOPp->MESI__DOT__READ) 
                                     | (IData)(vlTOPp->MESI__DOT__WRITE)) 
                                    | (IData)(vlTOPp->MESI__DOT__rREAD)) 
                                   | (IData)(vlTOPp->MESI__DOT__rWRITE));
    if (((IData)(vlTOPp->MESI__DOT__TAG_READ) ^ vlTOPp->MESI__DOT____Vtogcov__TAG_READ)) {
        ++(vlSymsp->__Vcoverage[149]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_READ = vlTOPp->MESI__DOT__TAG_READ;
    }
    vlTOPp->__Vfunc_MESI__DOT__READ_TAG_RAM__4__read_addr 
        = (0x3fU & (vlTOPp->addr >> 2U));
    vlTOPp->__Vfunc_MESI__DOT__READ_TAG_RAM__4__read 
        = vlTOPp->MESI__DOT__TAG_READ;
    vlTOPp->__Vfunc_MESI__DOT__READ_TAG_RAM__4__Vfuncout 
        = vlTOPp->MESI__DOT__TAG_RAM_rd_data;
    ++(vlSymsp->__Vcoverage[211]);
    vlTOPp->MESI__DOT__TAG_RAM_rd = vlTOPp->__Vfunc_MESI__DOT__READ_TAG_RAM__4__read;
    vlTOPp->MESI__DOT__TAG_RAM_rd_addr = vlTOPp->__Vfunc_MESI__DOT__READ_TAG_RAM__4__read_addr;
    vlTOPp->MESI__DOT__TAG_MATCH = (vlTOPp->__Vfunc_MESI__DOT__READ_TAG_RAM__4__Vfuncout 
                                    == (0xffffffU & 
                                        (vlTOPp->addr 
                                         >> 8U)));
    if (((IData)(vlTOPp->MESI__DOT__TAG_MATCH) ^ vlTOPp->MESI__DOT____Vtogcov__TAG_MATCH)) {
        ++(vlSymsp->__Vcoverage[148]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_MATCH = vlTOPp->MESI__DOT__TAG_MATCH;
    }
    vlTOPp->MESI__DOT__MESI_READ = ((IData)(vlTOPp->MESI__DOT__WRITE) 
                                    | ((IData)(vlTOPp->MESI__DOT__TAG_MATCH) 
                                       & ((IData)(vlTOPp->MESI__DOT__rREAD) 
                                          | (IData)(vlTOPp->MESI__DOT__rWRITE))));
    vlTOPp->MESI__DOT__TAG_WRITE = ((~ (IData)(vlTOPp->MESI__DOT__TAG_MATCH)) 
                                    & (IData)(vlTOPp->MESI__DOT__READ));
    vlTOPp->MESI__DOT__MESI_WRITE = (((IData)(vlTOPp->MESI__DOT__READ) 
                                      | (IData)(vlTOPp->MESI__DOT__WRITE)) 
                                     | ((IData)(vlTOPp->MESI__DOT__TAG_MATCH) 
                                        & ((IData)(vlTOPp->MESI__DOT__rREAD) 
                                           | (IData)(vlTOPp->MESI__DOT__rWRITE))));
    if (((IData)(vlTOPp->MESI__DOT__TAG_RAM_rd) ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd)) {
        ++(vlSymsp->__Vcoverage[109]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd = vlTOPp->MESI__DOT__TAG_RAM_rd;
    }
    if ((1U & ((IData)(vlTOPp->MESI__DOT__TAG_RAM_rd_addr) 
               ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_addr))) {
        ++(vlSymsp->__Vcoverage[110]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_addr 
            = ((0x3eU & (IData)(vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_addr)) 
               | (1U & (IData)(vlTOPp->MESI__DOT__TAG_RAM_rd_addr)));
    }
    if ((2U & ((IData)(vlTOPp->MESI__DOT__TAG_RAM_rd_addr) 
               ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_addr))) {
        ++(vlSymsp->__Vcoverage[111]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_addr 
            = ((0x3dU & (IData)(vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_addr)) 
               | (2U & (IData)(vlTOPp->MESI__DOT__TAG_RAM_rd_addr)));
    }
    if ((4U & ((IData)(vlTOPp->MESI__DOT__TAG_RAM_rd_addr) 
               ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_addr))) {
        ++(vlSymsp->__Vcoverage[112]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_addr 
            = ((0x3bU & (IData)(vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_addr)) 
               | (4U & (IData)(vlTOPp->MESI__DOT__TAG_RAM_rd_addr)));
    }
    if ((8U & ((IData)(vlTOPp->MESI__DOT__TAG_RAM_rd_addr) 
               ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_addr))) {
        ++(vlSymsp->__Vcoverage[113]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_addr 
            = ((0x37U & (IData)(vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_addr)) 
               | (8U & (IData)(vlTOPp->MESI__DOT__TAG_RAM_rd_addr)));
    }
    if ((0x10U & ((IData)(vlTOPp->MESI__DOT__TAG_RAM_rd_addr) 
                  ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_addr))) {
        ++(vlSymsp->__Vcoverage[114]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_addr 
            = ((0x2fU & (IData)(vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_addr)) 
               | (0x10U & (IData)(vlTOPp->MESI__DOT__TAG_RAM_rd_addr)));
    }
    if ((0x20U & ((IData)(vlTOPp->MESI__DOT__TAG_RAM_rd_addr) 
                  ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_addr))) {
        ++(vlSymsp->__Vcoverage[115]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_addr 
            = ((0x1fU & (IData)(vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_rd_addr)) 
               | (0x20U & (IData)(vlTOPp->MESI__DOT__TAG_RAM_rd_addr)));
    }
    if (((IData)(vlTOPp->MESI__DOT__MESI_READ) ^ vlTOPp->MESI__DOT____Vtogcov__MESI_READ)) {
        ++(vlSymsp->__Vcoverage[145]);
        vlTOPp->MESI__DOT____Vtogcov__MESI_READ = vlTOPp->MESI__DOT__MESI_READ;
    }
    vlTOPp->__Vfunc_MESI__DOT__READ_MESI_RAM__0__Vfuncout 
        = vlTOPp->MESI__DOT__MESI_RAM_rd_data;
    ++(vlSymsp->__Vcoverage[209]);
    vlTOPp->MESI__DOT__IS_EXCLUSIVE = (4U == (IData)(vlTOPp->__Vfunc_MESI__DOT__READ_MESI_RAM__0__Vfuncout));
    vlTOPp->__Vfunc_MESI__DOT__READ_MESI_RAM__1__Vfuncout 
        = vlTOPp->MESI__DOT__MESI_RAM_rd_data;
    ++(vlSymsp->__Vcoverage[209]);
    vlTOPp->MESI__DOT__IS_INVALID = (1U == (IData)(vlTOPp->__Vfunc_MESI__DOT__READ_MESI_RAM__1__Vfuncout));
    vlTOPp->__Vfunc_MESI__DOT__READ_MESI_RAM__2__Vfuncout 
        = vlTOPp->MESI__DOT__MESI_RAM_rd_data;
    ++(vlSymsp->__Vcoverage[209]);
    vlTOPp->MESI__DOT__IS_MODIFIED = (8U == (IData)(vlTOPp->__Vfunc_MESI__DOT__READ_MESI_RAM__2__Vfuncout));
    vlTOPp->__Vfunc_MESI__DOT__READ_MESI_RAM__3__read_addr 
        = (0x3fU & (vlTOPp->addr >> 2U));
    vlTOPp->__Vfunc_MESI__DOT__READ_MESI_RAM__3__read 
        = vlTOPp->MESI__DOT__MESI_READ;
    vlTOPp->__Vfunc_MESI__DOT__READ_MESI_RAM__3__Vfuncout 
        = vlTOPp->MESI__DOT__MESI_RAM_rd_data;
    ++(vlSymsp->__Vcoverage[209]);
    vlTOPp->MESI__DOT__MESI_RAM_rd = vlTOPp->__Vfunc_MESI__DOT__READ_MESI_RAM__3__read;
    vlTOPp->MESI__DOT__MESI_RAM_rd_addr = vlTOPp->__Vfunc_MESI__DOT__READ_MESI_RAM__3__read_addr;
    vlTOPp->MESI__DOT__IS_SHARED = (2U == (IData)(vlTOPp->__Vfunc_MESI__DOT__READ_MESI_RAM__3__Vfuncout));
    if (((IData)(vlTOPp->MESI__DOT__TAG_WRITE) ^ vlTOPp->MESI__DOT____Vtogcov__TAG_WRITE)) {
        ++(vlSymsp->__Vcoverage[150]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_WRITE = vlTOPp->MESI__DOT__TAG_WRITE;
    }
    if (((IData)(vlTOPp->MESI__DOT__MESI_WRITE) ^ vlTOPp->MESI__DOT____Vtogcov__MESI_WRITE)) {
        ++(vlSymsp->__Vcoverage[146]);
        vlTOPp->MESI__DOT____Vtogcov__MESI_WRITE = vlTOPp->MESI__DOT__MESI_WRITE;
    }
    if (((IData)(vlTOPp->MESI__DOT__IS_EXCLUSIVE) ^ vlTOPp->MESI__DOT____Vtogcov__IS_EXCLUSIVE)) {
        ++(vlSymsp->__Vcoverage[141]);
        vlTOPp->MESI__DOT____Vtogcov__IS_EXCLUSIVE 
            = vlTOPp->MESI__DOT__IS_EXCLUSIVE;
    }
    if (((IData)(vlTOPp->MESI__DOT__IS_INVALID) ^ vlTOPp->MESI__DOT____Vtogcov__IS_INVALID)) {
        ++(vlSymsp->__Vcoverage[142]);
        vlTOPp->MESI__DOT____Vtogcov__IS_INVALID = vlTOPp->MESI__DOT__IS_INVALID;
    }
    if (((IData)(vlTOPp->MESI__DOT__IS_MODIFIED) ^ vlTOPp->MESI__DOT____Vtogcov__IS_MODIFIED)) {
        ++(vlSymsp->__Vcoverage[143]);
        vlTOPp->MESI__DOT____Vtogcov__IS_MODIFIED = vlTOPp->MESI__DOT__IS_MODIFIED;
    }
    if (((IData)(vlTOPp->MESI__DOT__IS_SHARED) ^ vlTOPp->MESI__DOT____Vtogcov__IS_SHARED)) {
        ++(vlSymsp->__Vcoverage[144]);
        vlTOPp->MESI__DOT____Vtogcov__IS_SHARED = vlTOPp->MESI__DOT__IS_SHARED;
    }
    if (((IData)(vlTOPp->MESI__DOT__MESI_RAM_rd) ^ vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_rd)) {
        ++(vlSymsp->__Vcoverage[67]);
        vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_rd = vlTOPp->MESI__DOT__MESI_RAM_rd;
    }
    if ((1U & ((IData)(vlTOPp->MESI__DOT__MESI_RAM_rd_addr) 
               ^ vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_rd_addr))) {
        ++(vlSymsp->__Vcoverage[68]);
        vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_rd_addr 
            = ((0x3eU & (IData)(vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_rd_addr)) 
               | (1U & (IData)(vlTOPp->MESI__DOT__MESI_RAM_rd_addr)));
    }
    if ((2U & ((IData)(vlTOPp->MESI__DOT__MESI_RAM_rd_addr) 
               ^ vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_rd_addr))) {
        ++(vlSymsp->__Vcoverage[69]);
        vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_rd_addr 
            = ((0x3dU & (IData)(vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_rd_addr)) 
               | (2U & (IData)(vlTOPp->MESI__DOT__MESI_RAM_rd_addr)));
    }
    if ((4U & ((IData)(vlTOPp->MESI__DOT__MESI_RAM_rd_addr) 
               ^ vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_rd_addr))) {
        ++(vlSymsp->__Vcoverage[70]);
        vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_rd_addr 
            = ((0x3bU & (IData)(vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_rd_addr)) 
               | (4U & (IData)(vlTOPp->MESI__DOT__MESI_RAM_rd_addr)));
    }
    if ((8U & ((IData)(vlTOPp->MESI__DOT__MESI_RAM_rd_addr) 
               ^ vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_rd_addr))) {
        ++(vlSymsp->__Vcoverage[71]);
        vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_rd_addr 
            = ((0x37U & (IData)(vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_rd_addr)) 
               | (8U & (IData)(vlTOPp->MESI__DOT__MESI_RAM_rd_addr)));
    }
    if ((0x10U & ((IData)(vlTOPp->MESI__DOT__MESI_RAM_rd_addr) 
                  ^ vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_rd_addr))) {
        ++(vlSymsp->__Vcoverage[72]);
        vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_rd_addr 
            = ((0x2fU & (IData)(vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_rd_addr)) 
               | (0x10U & (IData)(vlTOPp->MESI__DOT__MESI_RAM_rd_addr)));
    }
    if ((0x20U & ((IData)(vlTOPp->MESI__DOT__MESI_RAM_rd_addr) 
                  ^ vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_rd_addr))) {
        ++(vlSymsp->__Vcoverage[73]);
        vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_rd_addr 
            = ((0x1fU & (IData)(vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_rd_addr)) 
               | (0x20U & (IData)(vlTOPp->MESI__DOT__MESI_RAM_rd_addr)));
    }
}

VL_INLINE_OPT void VMESI::_sequent__TOP__4(VMESI__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_DBG_MSGF("+    VMESI::_sequent__TOP__4\n"); );
    VMESI* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Variables
    CData/*5:0*/ __Vdlyvdim0__MESI__DOT__MESI_RAM__DOT__MEMORY__v0;
    CData/*3:0*/ __Vdlyvval__MESI__DOT__MESI_RAM__DOT__MEMORY__v0;
    CData/*0:0*/ __Vdlyvset__MESI__DOT__MESI_RAM__DOT__MEMORY__v0;
    CData/*5:0*/ __Vdlyvdim0__MESI__DOT__TAG_RAM__DOT__MEMORY__v0;
    CData/*0:0*/ __Vdlyvset__MESI__DOT__TAG_RAM__DOT__MEMORY__v0;
    IData/*23:0*/ __Vdlyvval__MESI__DOT__TAG_RAM__DOT__MEMORY__v0;
    // Body
    if (((IData)(vlTOPp->rd) & (IData)(vlTOPp->wr))) {
        ++(vlSymsp->__Vcoverage[162]);
    }
    __Vdlyvset__MESI__DOT__TAG_RAM__DOT__MEMORY__v0 = 0U;
    __Vdlyvset__MESI__DOT__MESI_RAM__DOT__MEMORY__v0 = 0U;
    ++(vlSymsp->__Vcoverage[478]);
    if (vlTOPp->MESI__DOT__TAG_RAM_wr) {
        ++(vlSymsp->__Vcoverage[476]);
        __Vdlyvval__MESI__DOT__TAG_RAM__DOT__MEMORY__v0 
            = vlTOPp->MESI__DOT__TAG_RAM_wr_data;
        __Vdlyvset__MESI__DOT__TAG_RAM__DOT__MEMORY__v0 = 1U;
        __Vdlyvdim0__MESI__DOT__TAG_RAM__DOT__MEMORY__v0 
            = vlTOPp->MESI__DOT__TAG_RAM_wr_addr;
    } else {
        ++(vlSymsp->__Vcoverage[477]);
    }
    ++(vlSymsp->__Vcoverage[473]);
    if (vlTOPp->MESI__DOT__MESI_RAM_wr) {
        ++(vlSymsp->__Vcoverage[471]);
        __Vdlyvval__MESI__DOT__MESI_RAM__DOT__MEMORY__v0 
            = vlTOPp->MESI__DOT__MESI_RAM_wr_data;
        __Vdlyvset__MESI__DOT__MESI_RAM__DOT__MEMORY__v0 = 1U;
        __Vdlyvdim0__MESI__DOT__MESI_RAM__DOT__MEMORY__v0 
            = vlTOPp->MESI__DOT__MESI_RAM_wr_addr;
    } else {
        ++(vlSymsp->__Vcoverage[472]);
    }
    if (__Vdlyvset__MESI__DOT__TAG_RAM__DOT__MEMORY__v0) {
        vlTOPp->MESI__DOT__TAG_RAM__DOT__MEMORY[__Vdlyvdim0__MESI__DOT__TAG_RAM__DOT__MEMORY__v0] 
            = __Vdlyvval__MESI__DOT__TAG_RAM__DOT__MEMORY__v0;
    }
    if (__Vdlyvset__MESI__DOT__MESI_RAM__DOT__MEMORY__v0) {
        vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY[__Vdlyvdim0__MESI__DOT__MESI_RAM__DOT__MEMORY__v0] 
            = __Vdlyvval__MESI__DOT__MESI_RAM__DOT__MEMORY__v0;
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0U]))) {
        ++(vlSymsp->__Vcoverage[213]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0U] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0U]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                         [0U]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0U]))) {
        ++(vlSymsp->__Vcoverage[214]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0U] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0U]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                         [0U]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0U]))) {
        ++(vlSymsp->__Vcoverage[215]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0U] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0U]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                         [0U]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0U]))) {
        ++(vlSymsp->__Vcoverage[216]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0U] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0U]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                         [0U]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [1U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [1U]))) {
        ++(vlSymsp->__Vcoverage[217]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[1U] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [1U]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                         [1U]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [1U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [1U]))) {
        ++(vlSymsp->__Vcoverage[218]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[1U] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [1U]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                         [1U]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [1U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [1U]))) {
        ++(vlSymsp->__Vcoverage[219]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[1U] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [1U]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                         [1U]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [1U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [1U]))) {
        ++(vlSymsp->__Vcoverage[220]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[1U] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [1U]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                         [1U]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [2U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [2U]))) {
        ++(vlSymsp->__Vcoverage[221]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[2U] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [2U]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                         [2U]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [2U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [2U]))) {
        ++(vlSymsp->__Vcoverage[222]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[2U] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [2U]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                         [2U]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [2U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [2U]))) {
        ++(vlSymsp->__Vcoverage[223]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[2U] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [2U]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                         [2U]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [2U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [2U]))) {
        ++(vlSymsp->__Vcoverage[224]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[2U] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [2U]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                         [2U]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [3U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [3U]))) {
        ++(vlSymsp->__Vcoverage[225]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[3U] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [3U]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                         [3U]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [3U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [3U]))) {
        ++(vlSymsp->__Vcoverage[226]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[3U] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [3U]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                         [3U]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [3U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [3U]))) {
        ++(vlSymsp->__Vcoverage[227]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[3U] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [3U]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                         [3U]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [3U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [3U]))) {
        ++(vlSymsp->__Vcoverage[228]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[3U] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [3U]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                         [3U]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [4U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [4U]))) {
        ++(vlSymsp->__Vcoverage[229]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[4U] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [4U]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                         [4U]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [4U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [4U]))) {
        ++(vlSymsp->__Vcoverage[230]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[4U] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [4U]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                         [4U]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [4U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [4U]))) {
        ++(vlSymsp->__Vcoverage[231]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[4U] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [4U]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                         [4U]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [4U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [4U]))) {
        ++(vlSymsp->__Vcoverage[232]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[4U] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [4U]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                         [4U]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [5U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [5U]))) {
        ++(vlSymsp->__Vcoverage[233]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[5U] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [5U]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                         [5U]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [5U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [5U]))) {
        ++(vlSymsp->__Vcoverage[234]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[5U] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [5U]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                         [5U]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [5U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [5U]))) {
        ++(vlSymsp->__Vcoverage[235]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[5U] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [5U]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                         [5U]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [5U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [5U]))) {
        ++(vlSymsp->__Vcoverage[236]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[5U] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [5U]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                         [5U]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [6U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [6U]))) {
        ++(vlSymsp->__Vcoverage[237]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[6U] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [6U]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                         [6U]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [6U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [6U]))) {
        ++(vlSymsp->__Vcoverage[238]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[6U] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [6U]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                         [6U]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [6U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [6U]))) {
        ++(vlSymsp->__Vcoverage[239]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[6U] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [6U]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                         [6U]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [6U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [6U]))) {
        ++(vlSymsp->__Vcoverage[240]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[6U] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [6U]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                         [6U]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [7U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [7U]))) {
        ++(vlSymsp->__Vcoverage[241]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[7U] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [7U]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                         [7U]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [7U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [7U]))) {
        ++(vlSymsp->__Vcoverage[242]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[7U] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [7U]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                         [7U]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [7U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [7U]))) {
        ++(vlSymsp->__Vcoverage[243]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[7U] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [7U]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                         [7U]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [7U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [7U]))) {
        ++(vlSymsp->__Vcoverage[244]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[7U] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [7U]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                         [7U]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [8U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [8U]))) {
        ++(vlSymsp->__Vcoverage[245]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[8U] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [8U]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                         [8U]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [8U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [8U]))) {
        ++(vlSymsp->__Vcoverage[246]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[8U] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [8U]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                         [8U]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [8U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [8U]))) {
        ++(vlSymsp->__Vcoverage[247]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[8U] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [8U]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                         [8U]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [8U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [8U]))) {
        ++(vlSymsp->__Vcoverage[248]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[8U] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [8U]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                         [8U]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [9U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [9U]))) {
        ++(vlSymsp->__Vcoverage[249]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[9U] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [9U]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                         [9U]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [9U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [9U]))) {
        ++(vlSymsp->__Vcoverage[250]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[9U] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [9U]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                         [9U]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [9U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [9U]))) {
        ++(vlSymsp->__Vcoverage[251]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[9U] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [9U]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                         [9U]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [9U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [9U]))) {
        ++(vlSymsp->__Vcoverage[252]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[9U] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [9U]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                         [9U]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0xaU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0xaU]))) {
        ++(vlSymsp->__Vcoverage[253]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0xaU] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0xaU]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                           [0xaU]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0xaU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0xaU]))) {
        ++(vlSymsp->__Vcoverage[254]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0xaU] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0xaU]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                           [0xaU]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0xaU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0xaU]))) {
        ++(vlSymsp->__Vcoverage[255]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0xaU] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0xaU]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                           [0xaU]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0xaU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0xaU]))) {
        ++(vlSymsp->__Vcoverage[256]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0xaU] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0xaU]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                           [0xaU]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0xbU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0xbU]))) {
        ++(vlSymsp->__Vcoverage[257]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0xbU] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0xbU]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                           [0xbU]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0xbU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0xbU]))) {
        ++(vlSymsp->__Vcoverage[258]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0xbU] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0xbU]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                           [0xbU]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0xbU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0xbU]))) {
        ++(vlSymsp->__Vcoverage[259]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0xbU] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0xbU]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                           [0xbU]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0xbU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0xbU]))) {
        ++(vlSymsp->__Vcoverage[260]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0xbU] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0xbU]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                           [0xbU]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0xcU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0xcU]))) {
        ++(vlSymsp->__Vcoverage[261]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0xcU] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0xcU]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                           [0xcU]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0xcU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0xcU]))) {
        ++(vlSymsp->__Vcoverage[262]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0xcU] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0xcU]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                           [0xcU]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0xcU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0xcU]))) {
        ++(vlSymsp->__Vcoverage[263]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0xcU] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0xcU]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                           [0xcU]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0xcU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0xcU]))) {
        ++(vlSymsp->__Vcoverage[264]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0xcU] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0xcU]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                           [0xcU]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0xdU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0xdU]))) {
        ++(vlSymsp->__Vcoverage[265]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0xdU] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0xdU]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                           [0xdU]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0xdU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0xdU]))) {
        ++(vlSymsp->__Vcoverage[266]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0xdU] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0xdU]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                           [0xdU]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0xdU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0xdU]))) {
        ++(vlSymsp->__Vcoverage[267]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0xdU] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0xdU]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                           [0xdU]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0xdU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0xdU]))) {
        ++(vlSymsp->__Vcoverage[268]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0xdU] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0xdU]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                           [0xdU]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0xeU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0xeU]))) {
        ++(vlSymsp->__Vcoverage[269]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0xeU] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0xeU]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                           [0xeU]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0xeU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0xeU]))) {
        ++(vlSymsp->__Vcoverage[270]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0xeU] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0xeU]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                           [0xeU]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0xeU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0xeU]))) {
        ++(vlSymsp->__Vcoverage[271]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0xeU] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0xeU]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                           [0xeU]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0xeU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0xeU]))) {
        ++(vlSymsp->__Vcoverage[272]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0xeU] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0xeU]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                           [0xeU]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0xfU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0xfU]))) {
        ++(vlSymsp->__Vcoverage[273]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0xfU] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0xfU]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                           [0xfU]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0xfU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0xfU]))) {
        ++(vlSymsp->__Vcoverage[274]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0xfU] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0xfU]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                           [0xfU]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0xfU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0xfU]))) {
        ++(vlSymsp->__Vcoverage[275]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0xfU] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0xfU]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                           [0xfU]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0xfU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0xfU]))) {
        ++(vlSymsp->__Vcoverage[276]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0xfU] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0xfU]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                           [0xfU]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x10U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x10U]))) {
        ++(vlSymsp->__Vcoverage[277]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x10U] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x10U]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x10U]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x10U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x10U]))) {
        ++(vlSymsp->__Vcoverage[278]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x10U] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x10U]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x10U]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x10U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x10U]))) {
        ++(vlSymsp->__Vcoverage[279]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x10U] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x10U]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x10U]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x10U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x10U]))) {
        ++(vlSymsp->__Vcoverage[280]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x10U] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x10U]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x10U]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x11U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x11U]))) {
        ++(vlSymsp->__Vcoverage[281]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x11U] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x11U]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x11U]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x11U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x11U]))) {
        ++(vlSymsp->__Vcoverage[282]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x11U] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x11U]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x11U]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x11U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x11U]))) {
        ++(vlSymsp->__Vcoverage[283]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x11U] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x11U]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x11U]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x11U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x11U]))) {
        ++(vlSymsp->__Vcoverage[284]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x11U] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x11U]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x11U]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x12U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x12U]))) {
        ++(vlSymsp->__Vcoverage[285]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x12U] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x12U]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x12U]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x12U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x12U]))) {
        ++(vlSymsp->__Vcoverage[286]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x12U] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x12U]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x12U]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x12U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x12U]))) {
        ++(vlSymsp->__Vcoverage[287]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x12U] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x12U]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x12U]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x12U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x12U]))) {
        ++(vlSymsp->__Vcoverage[288]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x12U] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x12U]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x12U]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x13U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x13U]))) {
        ++(vlSymsp->__Vcoverage[289]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x13U] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x13U]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x13U]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x13U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x13U]))) {
        ++(vlSymsp->__Vcoverage[290]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x13U] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x13U]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x13U]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x13U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x13U]))) {
        ++(vlSymsp->__Vcoverage[291]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x13U] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x13U]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x13U]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x13U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x13U]))) {
        ++(vlSymsp->__Vcoverage[292]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x13U] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x13U]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x13U]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x14U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x14U]))) {
        ++(vlSymsp->__Vcoverage[293]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x14U] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x14U]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x14U]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x14U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x14U]))) {
        ++(vlSymsp->__Vcoverage[294]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x14U] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x14U]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x14U]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x14U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x14U]))) {
        ++(vlSymsp->__Vcoverage[295]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x14U] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x14U]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x14U]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x14U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x14U]))) {
        ++(vlSymsp->__Vcoverage[296]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x14U] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x14U]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x14U]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x15U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x15U]))) {
        ++(vlSymsp->__Vcoverage[297]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x15U] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x15U]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x15U]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x15U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x15U]))) {
        ++(vlSymsp->__Vcoverage[298]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x15U] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x15U]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x15U]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x15U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x15U]))) {
        ++(vlSymsp->__Vcoverage[299]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x15U] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x15U]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x15U]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x15U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x15U]))) {
        ++(vlSymsp->__Vcoverage[300]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x15U] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x15U]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x15U]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x16U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x16U]))) {
        ++(vlSymsp->__Vcoverage[301]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x16U] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x16U]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x16U]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x16U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x16U]))) {
        ++(vlSymsp->__Vcoverage[302]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x16U] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x16U]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x16U]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x16U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x16U]))) {
        ++(vlSymsp->__Vcoverage[303]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x16U] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x16U]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x16U]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x16U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x16U]))) {
        ++(vlSymsp->__Vcoverage[304]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x16U] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x16U]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x16U]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x17U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x17U]))) {
        ++(vlSymsp->__Vcoverage[305]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x17U] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x17U]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x17U]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x17U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x17U]))) {
        ++(vlSymsp->__Vcoverage[306]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x17U] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x17U]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x17U]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x17U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x17U]))) {
        ++(vlSymsp->__Vcoverage[307]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x17U] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x17U]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x17U]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x17U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x17U]))) {
        ++(vlSymsp->__Vcoverage[308]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x17U] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x17U]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x17U]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x18U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x18U]))) {
        ++(vlSymsp->__Vcoverage[309]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x18U] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x18U]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x18U]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x18U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x18U]))) {
        ++(vlSymsp->__Vcoverage[310]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x18U] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x18U]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x18U]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x18U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x18U]))) {
        ++(vlSymsp->__Vcoverage[311]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x18U] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x18U]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x18U]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x18U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x18U]))) {
        ++(vlSymsp->__Vcoverage[312]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x18U] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x18U]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x18U]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x19U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x19U]))) {
        ++(vlSymsp->__Vcoverage[313]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x19U] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x19U]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x19U]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x19U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x19U]))) {
        ++(vlSymsp->__Vcoverage[314]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x19U] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x19U]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x19U]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x19U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x19U]))) {
        ++(vlSymsp->__Vcoverage[315]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x19U] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x19U]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x19U]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x19U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x19U]))) {
        ++(vlSymsp->__Vcoverage[316]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x19U] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x19U]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x19U]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x1aU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x1aU]))) {
        ++(vlSymsp->__Vcoverage[317]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x1aU] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x1aU]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x1aU]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x1aU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x1aU]))) {
        ++(vlSymsp->__Vcoverage[318]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x1aU] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x1aU]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x1aU]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x1aU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x1aU]))) {
        ++(vlSymsp->__Vcoverage[319]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x1aU] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x1aU]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x1aU]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x1aU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x1aU]))) {
        ++(vlSymsp->__Vcoverage[320]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x1aU] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x1aU]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x1aU]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x1bU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x1bU]))) {
        ++(vlSymsp->__Vcoverage[321]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x1bU] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x1bU]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x1bU]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x1bU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x1bU]))) {
        ++(vlSymsp->__Vcoverage[322]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x1bU] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x1bU]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x1bU]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x1bU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x1bU]))) {
        ++(vlSymsp->__Vcoverage[323]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x1bU] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x1bU]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x1bU]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x1bU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x1bU]))) {
        ++(vlSymsp->__Vcoverage[324]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x1bU] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x1bU]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x1bU]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x1cU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x1cU]))) {
        ++(vlSymsp->__Vcoverage[325]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x1cU] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x1cU]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x1cU]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x1cU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x1cU]))) {
        ++(vlSymsp->__Vcoverage[326]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x1cU] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x1cU]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x1cU]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x1cU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x1cU]))) {
        ++(vlSymsp->__Vcoverage[327]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x1cU] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x1cU]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x1cU]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x1cU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x1cU]))) {
        ++(vlSymsp->__Vcoverage[328]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x1cU] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x1cU]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x1cU]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x1dU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x1dU]))) {
        ++(vlSymsp->__Vcoverage[329]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x1dU] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x1dU]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x1dU]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x1dU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x1dU]))) {
        ++(vlSymsp->__Vcoverage[330]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x1dU] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x1dU]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x1dU]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x1dU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x1dU]))) {
        ++(vlSymsp->__Vcoverage[331]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x1dU] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x1dU]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x1dU]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x1dU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x1dU]))) {
        ++(vlSymsp->__Vcoverage[332]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x1dU] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x1dU]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x1dU]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x1eU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x1eU]))) {
        ++(vlSymsp->__Vcoverage[333]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x1eU] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x1eU]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x1eU]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x1eU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x1eU]))) {
        ++(vlSymsp->__Vcoverage[334]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x1eU] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x1eU]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x1eU]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x1eU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x1eU]))) {
        ++(vlSymsp->__Vcoverage[335]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x1eU] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x1eU]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x1eU]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x1eU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x1eU]))) {
        ++(vlSymsp->__Vcoverage[336]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x1eU] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x1eU]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x1eU]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x1fU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x1fU]))) {
        ++(vlSymsp->__Vcoverage[337]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x1fU] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x1fU]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x1fU]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x1fU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x1fU]))) {
        ++(vlSymsp->__Vcoverage[338]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x1fU] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x1fU]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x1fU]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x1fU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x1fU]))) {
        ++(vlSymsp->__Vcoverage[339]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x1fU] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x1fU]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x1fU]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x1fU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x1fU]))) {
        ++(vlSymsp->__Vcoverage[340]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x1fU] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x1fU]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x1fU]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x20U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x20U]))) {
        ++(vlSymsp->__Vcoverage[341]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x20U] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x20U]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x20U]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x20U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x20U]))) {
        ++(vlSymsp->__Vcoverage[342]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x20U] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x20U]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x20U]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x20U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x20U]))) {
        ++(vlSymsp->__Vcoverage[343]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x20U] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x20U]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x20U]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x20U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x20U]))) {
        ++(vlSymsp->__Vcoverage[344]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x20U] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x20U]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x20U]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x21U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x21U]))) {
        ++(vlSymsp->__Vcoverage[345]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x21U] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x21U]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x21U]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x21U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x21U]))) {
        ++(vlSymsp->__Vcoverage[346]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x21U] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x21U]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x21U]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x21U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x21U]))) {
        ++(vlSymsp->__Vcoverage[347]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x21U] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x21U]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x21U]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x21U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x21U]))) {
        ++(vlSymsp->__Vcoverage[348]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x21U] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x21U]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x21U]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x22U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x22U]))) {
        ++(vlSymsp->__Vcoverage[349]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x22U] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x22U]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x22U]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x22U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x22U]))) {
        ++(vlSymsp->__Vcoverage[350]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x22U] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x22U]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x22U]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x22U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x22U]))) {
        ++(vlSymsp->__Vcoverage[351]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x22U] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x22U]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x22U]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x22U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x22U]))) {
        ++(vlSymsp->__Vcoverage[352]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x22U] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x22U]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x22U]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x23U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x23U]))) {
        ++(vlSymsp->__Vcoverage[353]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x23U] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x23U]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x23U]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x23U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x23U]))) {
        ++(vlSymsp->__Vcoverage[354]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x23U] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x23U]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x23U]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x23U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x23U]))) {
        ++(vlSymsp->__Vcoverage[355]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x23U] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x23U]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x23U]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x23U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x23U]))) {
        ++(vlSymsp->__Vcoverage[356]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x23U] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x23U]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x23U]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x24U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x24U]))) {
        ++(vlSymsp->__Vcoverage[357]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x24U] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x24U]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x24U]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x24U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x24U]))) {
        ++(vlSymsp->__Vcoverage[358]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x24U] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x24U]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x24U]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x24U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x24U]))) {
        ++(vlSymsp->__Vcoverage[359]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x24U] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x24U]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x24U]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x24U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x24U]))) {
        ++(vlSymsp->__Vcoverage[360]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x24U] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x24U]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x24U]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x25U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x25U]))) {
        ++(vlSymsp->__Vcoverage[361]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x25U] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x25U]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x25U]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x25U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x25U]))) {
        ++(vlSymsp->__Vcoverage[362]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x25U] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x25U]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x25U]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x25U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x25U]))) {
        ++(vlSymsp->__Vcoverage[363]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x25U] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x25U]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x25U]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x25U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x25U]))) {
        ++(vlSymsp->__Vcoverage[364]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x25U] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x25U]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x25U]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x26U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x26U]))) {
        ++(vlSymsp->__Vcoverage[365]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x26U] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x26U]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x26U]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x26U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x26U]))) {
        ++(vlSymsp->__Vcoverage[366]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x26U] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x26U]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x26U]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x26U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x26U]))) {
        ++(vlSymsp->__Vcoverage[367]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x26U] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x26U]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x26U]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x26U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x26U]))) {
        ++(vlSymsp->__Vcoverage[368]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x26U] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x26U]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x26U]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x27U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x27U]))) {
        ++(vlSymsp->__Vcoverage[369]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x27U] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x27U]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x27U]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x27U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x27U]))) {
        ++(vlSymsp->__Vcoverage[370]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x27U] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x27U]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x27U]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x27U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x27U]))) {
        ++(vlSymsp->__Vcoverage[371]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x27U] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x27U]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x27U]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x27U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x27U]))) {
        ++(vlSymsp->__Vcoverage[372]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x27U] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x27U]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x27U]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x28U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x28U]))) {
        ++(vlSymsp->__Vcoverage[373]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x28U] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x28U]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x28U]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x28U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x28U]))) {
        ++(vlSymsp->__Vcoverage[374]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x28U] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x28U]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x28U]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x28U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x28U]))) {
        ++(vlSymsp->__Vcoverage[375]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x28U] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x28U]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x28U]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x28U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x28U]))) {
        ++(vlSymsp->__Vcoverage[376]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x28U] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x28U]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x28U]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x29U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x29U]))) {
        ++(vlSymsp->__Vcoverage[377]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x29U] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x29U]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x29U]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x29U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x29U]))) {
        ++(vlSymsp->__Vcoverage[378]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x29U] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x29U]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x29U]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x29U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x29U]))) {
        ++(vlSymsp->__Vcoverage[379]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x29U] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x29U]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x29U]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x29U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x29U]))) {
        ++(vlSymsp->__Vcoverage[380]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x29U] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x29U]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x29U]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x2aU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x2aU]))) {
        ++(vlSymsp->__Vcoverage[381]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x2aU] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x2aU]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x2aU]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x2aU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x2aU]))) {
        ++(vlSymsp->__Vcoverage[382]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x2aU] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x2aU]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x2aU]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x2aU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x2aU]))) {
        ++(vlSymsp->__Vcoverage[383]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x2aU] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x2aU]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x2aU]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x2aU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x2aU]))) {
        ++(vlSymsp->__Vcoverage[384]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x2aU] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x2aU]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x2aU]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x2bU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x2bU]))) {
        ++(vlSymsp->__Vcoverage[385]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x2bU] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x2bU]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x2bU]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x2bU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x2bU]))) {
        ++(vlSymsp->__Vcoverage[386]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x2bU] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x2bU]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x2bU]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x2bU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x2bU]))) {
        ++(vlSymsp->__Vcoverage[387]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x2bU] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x2bU]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x2bU]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x2bU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x2bU]))) {
        ++(vlSymsp->__Vcoverage[388]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x2bU] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x2bU]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x2bU]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x2cU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x2cU]))) {
        ++(vlSymsp->__Vcoverage[389]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x2cU] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x2cU]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x2cU]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x2cU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x2cU]))) {
        ++(vlSymsp->__Vcoverage[390]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x2cU] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x2cU]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x2cU]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x2cU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x2cU]))) {
        ++(vlSymsp->__Vcoverage[391]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x2cU] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x2cU]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x2cU]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x2cU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x2cU]))) {
        ++(vlSymsp->__Vcoverage[392]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x2cU] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x2cU]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x2cU]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x2dU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x2dU]))) {
        ++(vlSymsp->__Vcoverage[393]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x2dU] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x2dU]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x2dU]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x2dU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x2dU]))) {
        ++(vlSymsp->__Vcoverage[394]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x2dU] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x2dU]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x2dU]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x2dU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x2dU]))) {
        ++(vlSymsp->__Vcoverage[395]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x2dU] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x2dU]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x2dU]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x2dU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x2dU]))) {
        ++(vlSymsp->__Vcoverage[396]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x2dU] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x2dU]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x2dU]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x2eU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x2eU]))) {
        ++(vlSymsp->__Vcoverage[397]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x2eU] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x2eU]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x2eU]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x2eU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x2eU]))) {
        ++(vlSymsp->__Vcoverage[398]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x2eU] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x2eU]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x2eU]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x2eU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x2eU]))) {
        ++(vlSymsp->__Vcoverage[399]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x2eU] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x2eU]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x2eU]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x2eU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x2eU]))) {
        ++(vlSymsp->__Vcoverage[400]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x2eU] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x2eU]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x2eU]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x2fU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x2fU]))) {
        ++(vlSymsp->__Vcoverage[401]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x2fU] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x2fU]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x2fU]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x2fU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x2fU]))) {
        ++(vlSymsp->__Vcoverage[402]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x2fU] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x2fU]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x2fU]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x2fU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x2fU]))) {
        ++(vlSymsp->__Vcoverage[403]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x2fU] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x2fU]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x2fU]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x2fU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x2fU]))) {
        ++(vlSymsp->__Vcoverage[404]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x2fU] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x2fU]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x2fU]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x30U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x30U]))) {
        ++(vlSymsp->__Vcoverage[405]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x30U] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x30U]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x30U]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x30U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x30U]))) {
        ++(vlSymsp->__Vcoverage[406]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x30U] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x30U]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x30U]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x30U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x30U]))) {
        ++(vlSymsp->__Vcoverage[407]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x30U] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x30U]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x30U]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x30U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x30U]))) {
        ++(vlSymsp->__Vcoverage[408]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x30U] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x30U]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x30U]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x31U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x31U]))) {
        ++(vlSymsp->__Vcoverage[409]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x31U] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x31U]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x31U]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x31U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x31U]))) {
        ++(vlSymsp->__Vcoverage[410]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x31U] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x31U]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x31U]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x31U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x31U]))) {
        ++(vlSymsp->__Vcoverage[411]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x31U] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x31U]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x31U]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x31U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x31U]))) {
        ++(vlSymsp->__Vcoverage[412]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x31U] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x31U]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x31U]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x32U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x32U]))) {
        ++(vlSymsp->__Vcoverage[413]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x32U] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x32U]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x32U]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x32U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x32U]))) {
        ++(vlSymsp->__Vcoverage[414]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x32U] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x32U]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x32U]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x32U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x32U]))) {
        ++(vlSymsp->__Vcoverage[415]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x32U] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x32U]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x32U]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x32U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x32U]))) {
        ++(vlSymsp->__Vcoverage[416]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x32U] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x32U]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x32U]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x33U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x33U]))) {
        ++(vlSymsp->__Vcoverage[417]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x33U] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x33U]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x33U]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x33U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x33U]))) {
        ++(vlSymsp->__Vcoverage[418]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x33U] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x33U]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x33U]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x33U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x33U]))) {
        ++(vlSymsp->__Vcoverage[419]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x33U] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x33U]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x33U]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x33U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x33U]))) {
        ++(vlSymsp->__Vcoverage[420]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x33U] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x33U]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x33U]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x34U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x34U]))) {
        ++(vlSymsp->__Vcoverage[421]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x34U] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x34U]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x34U]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x34U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x34U]))) {
        ++(vlSymsp->__Vcoverage[422]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x34U] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x34U]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x34U]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x34U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x34U]))) {
        ++(vlSymsp->__Vcoverage[423]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x34U] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x34U]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x34U]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x34U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x34U]))) {
        ++(vlSymsp->__Vcoverage[424]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x34U] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x34U]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x34U]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x35U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x35U]))) {
        ++(vlSymsp->__Vcoverage[425]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x35U] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x35U]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x35U]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x35U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x35U]))) {
        ++(vlSymsp->__Vcoverage[426]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x35U] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x35U]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x35U]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x35U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x35U]))) {
        ++(vlSymsp->__Vcoverage[427]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x35U] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x35U]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x35U]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x35U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x35U]))) {
        ++(vlSymsp->__Vcoverage[428]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x35U] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x35U]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x35U]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x36U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x36U]))) {
        ++(vlSymsp->__Vcoverage[429]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x36U] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x36U]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x36U]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x36U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x36U]))) {
        ++(vlSymsp->__Vcoverage[430]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x36U] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x36U]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x36U]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x36U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x36U]))) {
        ++(vlSymsp->__Vcoverage[431]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x36U] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x36U]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x36U]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x36U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x36U]))) {
        ++(vlSymsp->__Vcoverage[432]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x36U] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x36U]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x36U]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x37U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x37U]))) {
        ++(vlSymsp->__Vcoverage[433]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x37U] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x37U]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x37U]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x37U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x37U]))) {
        ++(vlSymsp->__Vcoverage[434]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x37U] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x37U]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x37U]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x37U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x37U]))) {
        ++(vlSymsp->__Vcoverage[435]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x37U] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x37U]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x37U]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x37U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x37U]))) {
        ++(vlSymsp->__Vcoverage[436]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x37U] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x37U]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x37U]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x38U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x38U]))) {
        ++(vlSymsp->__Vcoverage[437]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x38U] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x38U]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x38U]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x38U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x38U]))) {
        ++(vlSymsp->__Vcoverage[438]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x38U] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x38U]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x38U]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x38U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x38U]))) {
        ++(vlSymsp->__Vcoverage[439]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x38U] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x38U]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x38U]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x38U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x38U]))) {
        ++(vlSymsp->__Vcoverage[440]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x38U] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x38U]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x38U]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x39U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x39U]))) {
        ++(vlSymsp->__Vcoverage[441]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x39U] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x39U]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x39U]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x39U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x39U]))) {
        ++(vlSymsp->__Vcoverage[442]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x39U] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x39U]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x39U]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x39U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x39U]))) {
        ++(vlSymsp->__Vcoverage[443]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x39U] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x39U]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x39U]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x39U] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x39U]))) {
        ++(vlSymsp->__Vcoverage[444]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x39U] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x39U]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x39U]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x3aU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x3aU]))) {
        ++(vlSymsp->__Vcoverage[445]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x3aU] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x3aU]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x3aU]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x3aU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x3aU]))) {
        ++(vlSymsp->__Vcoverage[446]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x3aU] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x3aU]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x3aU]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x3aU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x3aU]))) {
        ++(vlSymsp->__Vcoverage[447]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x3aU] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x3aU]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x3aU]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x3aU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x3aU]))) {
        ++(vlSymsp->__Vcoverage[448]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x3aU] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x3aU]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x3aU]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x3bU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x3bU]))) {
        ++(vlSymsp->__Vcoverage[449]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x3bU] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x3bU]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x3bU]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x3bU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x3bU]))) {
        ++(vlSymsp->__Vcoverage[450]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x3bU] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x3bU]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x3bU]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x3bU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x3bU]))) {
        ++(vlSymsp->__Vcoverage[451]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x3bU] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x3bU]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x3bU]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x3bU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x3bU]))) {
        ++(vlSymsp->__Vcoverage[452]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x3bU] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x3bU]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x3bU]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x3cU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x3cU]))) {
        ++(vlSymsp->__Vcoverage[453]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x3cU] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x3cU]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x3cU]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x3cU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x3cU]))) {
        ++(vlSymsp->__Vcoverage[454]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x3cU] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x3cU]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x3cU]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x3cU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x3cU]))) {
        ++(vlSymsp->__Vcoverage[455]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x3cU] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x3cU]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x3cU]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x3cU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x3cU]))) {
        ++(vlSymsp->__Vcoverage[456]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x3cU] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x3cU]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x3cU]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x3dU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x3dU]))) {
        ++(vlSymsp->__Vcoverage[457]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x3dU] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x3dU]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x3dU]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x3dU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x3dU]))) {
        ++(vlSymsp->__Vcoverage[458]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x3dU] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x3dU]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x3dU]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x3dU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x3dU]))) {
        ++(vlSymsp->__Vcoverage[459]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x3dU] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x3dU]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x3dU]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x3dU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x3dU]))) {
        ++(vlSymsp->__Vcoverage[460]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x3dU] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x3dU]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x3dU]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x3eU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x3eU]))) {
        ++(vlSymsp->__Vcoverage[461]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x3eU] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x3eU]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x3eU]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x3eU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x3eU]))) {
        ++(vlSymsp->__Vcoverage[462]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x3eU] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x3eU]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x3eU]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x3eU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x3eU]))) {
        ++(vlSymsp->__Vcoverage[463]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x3eU] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x3eU]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x3eU]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x3eU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x3eU]))) {
        ++(vlSymsp->__Vcoverage[464]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x3eU] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x3eU]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x3eU]));
    }
    if ((1U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x3fU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x3fU]))) {
        ++(vlSymsp->__Vcoverage[465]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x3fU] 
            = ((0xeU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x3fU]) | (1U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x3fU]));
    }
    if ((2U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x3fU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x3fU]))) {
        ++(vlSymsp->__Vcoverage[466]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x3fU] 
            = ((0xdU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x3fU]) | (2U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x3fU]));
    }
    if ((4U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x3fU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x3fU]))) {
        ++(vlSymsp->__Vcoverage[467]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x3fU] 
            = ((0xbU & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x3fU]) | (4U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x3fU]));
    }
    if ((8U & (vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
               [0x3fU] ^ vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
               [0x3fU]))) {
        ++(vlSymsp->__Vcoverage[468]);
        vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY[0x3fU] 
            = ((7U & vlTOPp->MESI__DOT__MESI_RAM__DOT____Vtogcov__MEMORY
                [0x3fU]) | (8U & vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                            [0x3fU]));
    }
}

VL_INLINE_OPT void VMESI::_sequent__TOP__5(VMESI__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_DBG_MSGF("+    VMESI::_sequent__TOP__5\n"); );
    VMESI* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    ++(vlSymsp->__Vcoverage[161]);
    if (VL_UNLIKELY(((IData)(vlTOPp->rd) & (IData)(vlTOPp->wr)))) {
        VL_WRITEF("*-* All Finished *-*\n");
        ++(vlSymsp->__Vcoverage[159]);
        VL_FINISH_MT("MESI.sv", 145, "");
    } else {
        ++(vlSymsp->__Vcoverage[160]);
    }
    if (vlTOPp->res_n) {
        ++(vlSymsp->__Vcoverage[158]);
        vlTOPp->MESI__DOT__STATE = vlTOPp->MESI__DOT__NEXT_STATE;
    } else {
        ++(vlSymsp->__Vcoverage[157]);
        vlTOPp->MESI__DOT__STATE = 0U;
    }
    if ((1U & ((IData)(vlTOPp->MESI__DOT__STATE) ^ vlTOPp->MESI__DOT____Vtogcov__STATE))) {
        ++(vlSymsp->__Vcoverage[50]);
        vlTOPp->MESI__DOT____Vtogcov__STATE = ((6U 
                                                & (IData)(vlTOPp->MESI__DOT____Vtogcov__STATE)) 
                                               | (1U 
                                                  & (IData)(vlTOPp->MESI__DOT__STATE)));
    }
    if ((2U & ((IData)(vlTOPp->MESI__DOT__STATE) ^ vlTOPp->MESI__DOT____Vtogcov__STATE))) {
        ++(vlSymsp->__Vcoverage[51]);
        vlTOPp->MESI__DOT____Vtogcov__STATE = ((5U 
                                                & (IData)(vlTOPp->MESI__DOT____Vtogcov__STATE)) 
                                               | (2U 
                                                  & (IData)(vlTOPp->MESI__DOT__STATE)));
    }
    if ((4U & ((IData)(vlTOPp->MESI__DOT__STATE) ^ vlTOPp->MESI__DOT____Vtogcov__STATE))) {
        ++(vlSymsp->__Vcoverage[52]);
        vlTOPp->MESI__DOT____Vtogcov__STATE = ((3U 
                                                & (IData)(vlTOPp->MESI__DOT____Vtogcov__STATE)) 
                                               | (4U 
                                                  & (IData)(vlTOPp->MESI__DOT__STATE)));
    }
}

VL_INLINE_OPT void VMESI::_combo__TOP__7(VMESI__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_DBG_MSGF("+    VMESI::_combo__TOP__7\n"); );
    VMESI* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    vlTOPp->MESI__DOT__TAG_RAM_rd_data = ((((IData)(vlTOPp->MESI__DOT__TAG_RAM_rd)
                                             ? vlTOPp->MESI__DOT__TAG_RAM__DOT__MEMORY
                                            [vlTOPp->MESI__DOT__TAG_RAM_rd_addr]
                                             : 0U) 
                                           & ((IData)(vlTOPp->MESI__DOT__TAG_RAM_rd)
                                               ? 0xffffffU
                                               : 0U)) 
                                          & ((IData)(vlTOPp->MESI__DOT__TAG_RAM_rd)
                                              ? 0xffffffU
                                              : 0U));
    vlTOPp->MESI__DOT__MESI_RAM_rd_data = ((((IData)(vlTOPp->MESI__DOT__MESI_RAM_rd)
                                              ? vlTOPp->MESI__DOT__MESI_RAM__DOT__MEMORY
                                             [vlTOPp->MESI__DOT__MESI_RAM_rd_addr]
                                              : 0U) 
                                            & ((IData)(vlTOPp->MESI__DOT__MESI_RAM_rd)
                                                ? 0xfU
                                                : 0U)) 
                                           & ((IData)(vlTOPp->MESI__DOT__MESI_RAM_rd)
                                               ? 0xfU
                                               : 0U));
    ++(vlSymsp->__Vcoverage[208]);
    if ((0U == (IData)(vlTOPp->MESI__DOT__STATE))) {
        ++(vlSymsp->__Vcoverage[179]);
        if (vlTOPp->MESI__DOT__IDLE) {
            vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__5__write_addr 
                = (0x3fU & (vlTOPp->addr >> 2U));
            vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__5__write 
                = vlTOPp->MESI__DOT__TAG_WRITE;
            ++(vlSymsp->__Vcoverage[212]);
            vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__6__write_addr 
                = (0x3fU & (vlTOPp->addr >> 2U));
            vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__6__write 
                = vlTOPp->MESI__DOT__MESI_WRITE;
            ++(vlSymsp->__Vcoverage[210]);
            ++(vlSymsp->__Vcoverage[163]);
            vlTOPp->MESI__DOT__NEXT_STATE = 0U;
            vlTOPp->MESI__DOT__TAG_RAM_wr = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__5__write;
            vlTOPp->MESI__DOT__TAG_RAM_wr_addr = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__5__write_addr;
            vlTOPp->MESI__DOT__TAG_RAM_wr_data = 0U;
            vlTOPp->MESI__DOT__MESI_RAM_wr = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__6__write;
            vlTOPp->MESI__DOT__MESI_RAM_wr_addr = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__6__write_addr;
            vlTOPp->MESI__DOT__MESI_RAM_wr_data = 0U;
            vlTOPp->err = 0U;
            vlTOPp->mesi = 0U;
            vlTOPp->index = (0x3fU & (vlTOPp->addr 
                                      >> 2U));
            vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__5__Vfuncout 
                = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__5__write;
            vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__6__Vfuncout 
                = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__6__write;
            vlTOPp->TAG_RAM_status = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__5__Vfuncout;
            vlTOPp->MESI_RAM_status = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__6__Vfuncout;
        } else {
            ++(vlSymsp->__Vcoverage[164]);
        }
        if (((IData)(vlTOPp->MESI__DOT__READ) & (IData)(vlTOPp->MESI__DOT__TAG_MATCH))) {
            vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__7__write_addr 
                = (0x3fU & (vlTOPp->addr >> 2U));
            vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__7__write 
                = vlTOPp->MESI__DOT__TAG_WRITE;
            ++(vlSymsp->__Vcoverage[212]);
            vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__8__write_addr 
                = (0x3fU & (vlTOPp->addr >> 2U));
            vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__8__write 
                = vlTOPp->MESI__DOT__MESI_WRITE;
            ++(vlSymsp->__Vcoverage[210]);
            ++(vlSymsp->__Vcoverage[165]);
            vlTOPp->MESI__DOT__NEXT_STATE = 1U;
            vlTOPp->MESI__DOT__TAG_RAM_wr = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__7__write;
            vlTOPp->MESI__DOT__TAG_RAM_wr_addr = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__7__write_addr;
            vlTOPp->MESI__DOT__TAG_RAM_wr_data = 0U;
            vlTOPp->MESI__DOT__MESI_RAM_wr = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__8__write;
            vlTOPp->MESI__DOT__MESI_RAM_wr_addr = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__8__write_addr;
            vlTOPp->MESI__DOT__MESI_RAM_wr_data = 4U;
            vlTOPp->err = 0U;
            vlTOPp->mesi = 4U;
            vlTOPp->index = (0x3fU & (vlTOPp->addr 
                                      >> 2U));
            vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__7__Vfuncout 
                = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__7__write;
            vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__8__Vfuncout 
                = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__8__write;
            vlTOPp->TAG_RAM_status = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__7__Vfuncout;
            vlTOPp->MESI_RAM_status = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__8__Vfuncout;
        } else {
            ++(vlSymsp->__Vcoverage[166]);
        }
        if (((IData)(vlTOPp->MESI__DOT__READ) & (~ (IData)(vlTOPp->MESI__DOT__TAG_MATCH)))) {
            vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__9__write_data 
                = (0xffffffU & (vlTOPp->addr >> 8U));
            vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__9__write_addr 
                = (0x3fU & (vlTOPp->addr >> 2U));
            vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__9__write 
                = vlTOPp->MESI__DOT__TAG_WRITE;
            ++(vlSymsp->__Vcoverage[212]);
            vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__10__write_addr 
                = (0x3fU & (vlTOPp->addr >> 2U));
            vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__10__write 
                = vlTOPp->MESI__DOT__MESI_WRITE;
            ++(vlSymsp->__Vcoverage[210]);
            ++(vlSymsp->__Vcoverage[167]);
            vlTOPp->MESI__DOT__NEXT_STATE = 1U;
            vlTOPp->MESI__DOT__TAG_RAM_wr = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__9__write;
            vlTOPp->MESI__DOT__TAG_RAM_wr_addr = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__9__write_addr;
            vlTOPp->MESI__DOT__TAG_RAM_wr_data = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__9__write_data;
            vlTOPp->MESI__DOT__MESI_RAM_wr = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__10__write;
            vlTOPp->MESI__DOT__MESI_RAM_wr_addr = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__10__write_addr;
            vlTOPp->MESI__DOT__MESI_RAM_wr_data = 4U;
            vlTOPp->err = 0U;
            vlTOPp->mesi = 4U;
            vlTOPp->index = (0x3fU & (vlTOPp->addr 
                                      >> 2U));
            vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__9__Vfuncout 
                = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__9__write;
            vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__10__Vfuncout 
                = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__10__write;
            vlTOPp->TAG_RAM_status = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__9__Vfuncout;
            vlTOPp->MESI_RAM_status = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__10__Vfuncout;
        } else {
            ++(vlSymsp->__Vcoverage[168]);
        }
        if (((IData)(vlTOPp->MESI__DOT__WRITE) & (IData)(vlTOPp->MESI__DOT__TAG_MATCH))) {
            vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__11__write_addr 
                = (0x3fU & (vlTOPp->addr >> 2U));
            vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__11__write 
                = vlTOPp->MESI__DOT__TAG_WRITE;
            ++(vlSymsp->__Vcoverage[212]);
            vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__12__write_addr 
                = (0x3fU & (vlTOPp->addr >> 2U));
            vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__12__write 
                = vlTOPp->MESI__DOT__MESI_WRITE;
            ++(vlSymsp->__Vcoverage[210]);
            ++(vlSymsp->__Vcoverage[169]);
            vlTOPp->MESI__DOT__NEXT_STATE = 2U;
            vlTOPp->MESI__DOT__TAG_RAM_wr = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__11__write;
            vlTOPp->MESI__DOT__TAG_RAM_wr_addr = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__11__write_addr;
            vlTOPp->MESI__DOT__TAG_RAM_wr_data = 0U;
            vlTOPp->MESI__DOT__MESI_RAM_wr = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__12__write;
            vlTOPp->MESI__DOT__MESI_RAM_wr_addr = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__12__write_addr;
            vlTOPp->MESI__DOT__MESI_RAM_wr_data = 8U;
            vlTOPp->err = 0U;
            vlTOPp->mesi = 8U;
            vlTOPp->index = (0x3fU & (vlTOPp->addr 
                                      >> 2U));
            vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__11__Vfuncout 
                = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__11__write;
            vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__12__Vfuncout 
                = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__12__write;
            vlTOPp->TAG_RAM_status = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__11__Vfuncout;
            vlTOPp->MESI_RAM_status = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__12__Vfuncout;
        } else {
            ++(vlSymsp->__Vcoverage[170]);
        }
        if (((IData)(vlTOPp->MESI__DOT__WRITE) & (~ (IData)(vlTOPp->MESI__DOT__TAG_MATCH)))) {
            vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__13__write_addr 
                = (0x3fU & (vlTOPp->addr >> 2U));
            vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__13__write 
                = vlTOPp->MESI__DOT__TAG_WRITE;
            ++(vlSymsp->__Vcoverage[212]);
            vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__14__write_addr 
                = (0x3fU & (vlTOPp->addr >> 2U));
            vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__14__write 
                = vlTOPp->MESI__DOT__MESI_WRITE;
            ++(vlSymsp->__Vcoverage[210]);
            ++(vlSymsp->__Vcoverage[171]);
            vlTOPp->MESI__DOT__NEXT_STATE = 2U;
            vlTOPp->MESI__DOT__TAG_RAM_wr = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__13__write;
            vlTOPp->MESI__DOT__TAG_RAM_wr_addr = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__13__write_addr;
            vlTOPp->MESI__DOT__TAG_RAM_wr_data = 0U;
            vlTOPp->MESI__DOT__MESI_RAM_wr = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__14__write;
            vlTOPp->MESI__DOT__MESI_RAM_wr_addr = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__14__write_addr;
            vlTOPp->MESI__DOT__MESI_RAM_wr_data = 0U;
            vlTOPp->err = 1U;
            vlTOPp->mesi = 0U;
            vlTOPp->index = (0x3fU & (vlTOPp->addr 
                                      >> 2U));
            vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__13__Vfuncout 
                = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__13__write;
            vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__14__Vfuncout 
                = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__14__write;
            vlTOPp->TAG_RAM_status = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__13__Vfuncout;
            vlTOPp->MESI_RAM_status = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__14__Vfuncout;
        } else {
            ++(vlSymsp->__Vcoverage[172]);
        }
        if (((IData)(vlTOPp->MESI__DOT__rWRITE) & (IData)(vlTOPp->MESI__DOT__TAG_MATCH))) {
            vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__15__write_addr 
                = (0x3fU & (vlTOPp->addr >> 2U));
            vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__15__write 
                = vlTOPp->MESI__DOT__TAG_WRITE;
            ++(vlSymsp->__Vcoverage[212]);
            vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__16__write_addr 
                = (0x3fU & (vlTOPp->addr >> 2U));
            vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__16__write 
                = vlTOPp->MESI__DOT__MESI_WRITE;
            ++(vlSymsp->__Vcoverage[210]);
            ++(vlSymsp->__Vcoverage[173]);
            vlTOPp->MESI__DOT__NEXT_STATE = 6U;
            vlTOPp->MESI__DOT__TAG_RAM_wr = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__15__write;
            vlTOPp->MESI__DOT__TAG_RAM_wr_addr = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__15__write_addr;
            vlTOPp->MESI__DOT__TAG_RAM_wr_data = 0U;
            vlTOPp->MESI__DOT__MESI_RAM_wr = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__16__write;
            vlTOPp->MESI__DOT__MESI_RAM_wr_addr = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__16__write_addr;
            vlTOPp->MESI__DOT__MESI_RAM_wr_data = 1U;
            vlTOPp->err = 0U;
            vlTOPp->mesi = 1U;
            vlTOPp->index = (0x3fU & (vlTOPp->addr 
                                      >> 2U));
            vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__15__Vfuncout 
                = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__15__write;
            vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__16__Vfuncout 
                = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__16__write;
            vlTOPp->TAG_RAM_status = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__15__Vfuncout;
            vlTOPp->MESI_RAM_status = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__16__Vfuncout;
        } else {
            ++(vlSymsp->__Vcoverage[174]);
        }
        if (((IData)(vlTOPp->MESI__DOT__rREAD) & (IData)(vlTOPp->MESI__DOT__TAG_MATCH))) {
            vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__17__write_addr 
                = (0x3fU & (vlTOPp->addr >> 2U));
            vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__17__write 
                = vlTOPp->MESI__DOT__TAG_WRITE;
            ++(vlSymsp->__Vcoverage[212]);
            vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__18__write_addr 
                = (0x3fU & (vlTOPp->addr >> 2U));
            vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__18__write 
                = vlTOPp->MESI__DOT__MESI_WRITE;
            ++(vlSymsp->__Vcoverage[210]);
            ++(vlSymsp->__Vcoverage[175]);
            vlTOPp->MESI__DOT__NEXT_STATE = 5U;
            vlTOPp->MESI__DOT__TAG_RAM_wr = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__17__write;
            vlTOPp->MESI__DOT__TAG_RAM_wr_addr = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__17__write_addr;
            vlTOPp->MESI__DOT__TAG_RAM_wr_data = 0U;
            vlTOPp->MESI__DOT__MESI_RAM_wr = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__18__write;
            vlTOPp->MESI__DOT__MESI_RAM_wr_addr = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__18__write_addr;
            vlTOPp->MESI__DOT__MESI_RAM_wr_data = 2U;
            vlTOPp->err = 0U;
            vlTOPp->mesi = 2U;
            vlTOPp->index = (0x3fU & (vlTOPp->addr 
                                      >> 2U));
            vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__17__Vfuncout 
                = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__17__write;
            vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__18__Vfuncout 
                = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__18__write;
            vlTOPp->TAG_RAM_status = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__17__Vfuncout;
            vlTOPp->MESI_RAM_status = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__18__Vfuncout;
        } else {
            ++(vlSymsp->__Vcoverage[176]);
        }
        if (((IData)(vlTOPp->MESI__DOT__rREAD) & (~ (IData)(vlTOPp->MESI__DOT__TAG_MATCH)))) {
            vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__19__write_addr 
                = (0x3fU & (vlTOPp->addr >> 2U));
            vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__19__write 
                = vlTOPp->MESI__DOT__TAG_WRITE;
            ++(vlSymsp->__Vcoverage[212]);
            vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__20__write_addr 
                = (0x3fU & (vlTOPp->addr >> 2U));
            vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__20__write 
                = vlTOPp->MESI__DOT__MESI_WRITE;
            ++(vlSymsp->__Vcoverage[210]);
            ++(vlSymsp->__Vcoverage[177]);
            vlTOPp->MESI__DOT__NEXT_STATE = 0U;
            vlTOPp->MESI__DOT__TAG_RAM_wr = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__19__write;
            vlTOPp->MESI__DOT__TAG_RAM_wr_addr = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__19__write_addr;
            vlTOPp->MESI__DOT__TAG_RAM_wr_data = 0U;
            vlTOPp->MESI__DOT__MESI_RAM_wr = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__20__write;
            vlTOPp->MESI__DOT__MESI_RAM_wr_addr = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__20__write_addr;
            vlTOPp->MESI__DOT__MESI_RAM_wr_data = 0U;
            vlTOPp->err = 0U;
            vlTOPp->mesi = 0U;
            vlTOPp->index = (0x3fU & (vlTOPp->addr 
                                      >> 2U));
            vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__19__Vfuncout 
                = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__19__write;
            vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__20__Vfuncout 
                = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__20__write;
            vlTOPp->TAG_RAM_status = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__19__Vfuncout;
            vlTOPp->MESI_RAM_status = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__20__Vfuncout;
        } else {
            ++(vlSymsp->__Vcoverage[178]);
        }
    } else {
        if ((1U == (IData)(vlTOPp->MESI__DOT__STATE))) {
            ++(vlSymsp->__Vcoverage[186]);
            if (vlTOPp->MESI__DOT__IDLE) {
                vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__21__write_addr 
                    = (0x3fU & (vlTOPp->addr >> 2U));
                vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__21__write 
                    = vlTOPp->MESI__DOT__TAG_WRITE;
                ++(vlSymsp->__Vcoverage[212]);
                vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__22__write_addr 
                    = (0x3fU & (vlTOPp->addr >> 2U));
                vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__22__write 
                    = vlTOPp->MESI__DOT__MESI_WRITE;
                ++(vlSymsp->__Vcoverage[210]);
                ++(vlSymsp->__Vcoverage[180]);
                vlTOPp->MESI__DOT__NEXT_STATE = 0U;
                vlTOPp->MESI__DOT__TAG_RAM_wr = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__21__write;
                vlTOPp->MESI__DOT__TAG_RAM_wr_addr 
                    = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__21__write_addr;
                vlTOPp->MESI__DOT__TAG_RAM_wr_data = 0U;
                vlTOPp->MESI__DOT__MESI_RAM_wr = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__22__write;
                vlTOPp->MESI__DOT__MESI_RAM_wr_addr 
                    = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__22__write_addr;
                vlTOPp->MESI__DOT__MESI_RAM_wr_data = 0U;
                vlTOPp->err = 0U;
                vlTOPp->mesi = 0U;
                vlTOPp->index = (0x3fU & (vlTOPp->addr 
                                          >> 2U));
                vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__21__Vfuncout 
                    = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__21__write;
                vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__22__Vfuncout 
                    = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__22__write;
                vlTOPp->TAG_RAM_status = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__21__Vfuncout;
                vlTOPp->MESI_RAM_status = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__22__Vfuncout;
            } else {
                ++(vlSymsp->__Vcoverage[181]);
            }
            if (((IData)(vlTOPp->MESI__DOT__READ) & (IData)(vlTOPp->MESI__DOT__TAG_MATCH))) {
                vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__23__write_addr 
                    = (0x3fU & (vlTOPp->addr >> 2U));
                vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__23__write 
                    = vlTOPp->MESI__DOT__TAG_WRITE;
                ++(vlSymsp->__Vcoverage[212]);
                vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__24__write_addr 
                    = (0x3fU & (vlTOPp->addr >> 2U));
                vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__24__write 
                    = vlTOPp->MESI__DOT__MESI_WRITE;
                ++(vlSymsp->__Vcoverage[210]);
                ++(vlSymsp->__Vcoverage[182]);
                vlTOPp->MESI__DOT__NEXT_STATE = 1U;
                vlTOPp->MESI__DOT__TAG_RAM_wr = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__23__write;
                vlTOPp->MESI__DOT__TAG_RAM_wr_addr 
                    = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__23__write_addr;
                vlTOPp->MESI__DOT__TAG_RAM_wr_data = 0U;
                vlTOPp->MESI__DOT__MESI_RAM_wr = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__24__write;
                vlTOPp->MESI__DOT__MESI_RAM_wr_addr 
                    = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__24__write_addr;
                vlTOPp->MESI__DOT__MESI_RAM_wr_data = 4U;
                vlTOPp->err = 0U;
                vlTOPp->mesi = 4U;
                vlTOPp->index = (0x3fU & (vlTOPp->addr 
                                          >> 2U));
                vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__23__Vfuncout 
                    = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__23__write;
                vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__24__Vfuncout 
                    = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__24__write;
                vlTOPp->TAG_RAM_status = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__23__Vfuncout;
                vlTOPp->MESI_RAM_status = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__24__Vfuncout;
            } else {
                ++(vlSymsp->__Vcoverage[183]);
            }
            if (((IData)(vlTOPp->MESI__DOT__READ) & 
                 (~ (IData)(vlTOPp->MESI__DOT__TAG_MATCH)))) {
                vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__25__write_data 
                    = (0xffffffU & (vlTOPp->addr >> 8U));
                vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__25__write_addr 
                    = (0x3fU & (vlTOPp->addr >> 2U));
                vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__25__write 
                    = vlTOPp->MESI__DOT__TAG_WRITE;
                ++(vlSymsp->__Vcoverage[212]);
                vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__26__write_addr 
                    = (0x3fU & (vlTOPp->addr >> 2U));
                vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__26__write 
                    = vlTOPp->MESI__DOT__MESI_WRITE;
                ++(vlSymsp->__Vcoverage[210]);
                ++(vlSymsp->__Vcoverage[184]);
                vlTOPp->MESI__DOT__NEXT_STATE = 1U;
                vlTOPp->MESI__DOT__TAG_RAM_wr = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__25__write;
                vlTOPp->MESI__DOT__TAG_RAM_wr_addr 
                    = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__25__write_addr;
                vlTOPp->MESI__DOT__TAG_RAM_wr_data 
                    = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__25__write_data;
                vlTOPp->MESI__DOT__MESI_RAM_wr = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__26__write;
                vlTOPp->MESI__DOT__MESI_RAM_wr_addr 
                    = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__26__write_addr;
                vlTOPp->MESI__DOT__MESI_RAM_wr_data = 4U;
                vlTOPp->err = 0U;
                vlTOPp->mesi = 4U;
                vlTOPp->index = (0x3fU & (vlTOPp->addr 
                                          >> 2U));
                vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__25__Vfuncout 
                    = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__25__write;
                vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__26__Vfuncout 
                    = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__26__write;
                vlTOPp->TAG_RAM_status = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__25__Vfuncout;
                vlTOPp->MESI_RAM_status = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__26__Vfuncout;
            } else {
                ++(vlSymsp->__Vcoverage[185]);
            }
        } else {
            if ((2U == (IData)(vlTOPp->MESI__DOT__STATE))) {
                ++(vlSymsp->__Vcoverage[193]);
                if (vlTOPp->MESI__DOT__IDLE) {
                    vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__27__write_addr 
                        = (0x3fU & (vlTOPp->addr >> 2U));
                    vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__27__write 
                        = vlTOPp->MESI__DOT__TAG_WRITE;
                    ++(vlSymsp->__Vcoverage[212]);
                    vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__28__write_addr 
                        = (0x3fU & (vlTOPp->addr >> 2U));
                    vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__28__write 
                        = vlTOPp->MESI__DOT__MESI_WRITE;
                    ++(vlSymsp->__Vcoverage[210]);
                    ++(vlSymsp->__Vcoverage[187]);
                    vlTOPp->MESI__DOT__NEXT_STATE = 0U;
                    vlTOPp->MESI__DOT__TAG_RAM_wr = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__27__write;
                    vlTOPp->MESI__DOT__TAG_RAM_wr_addr 
                        = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__27__write_addr;
                    vlTOPp->MESI__DOT__TAG_RAM_wr_data = 0U;
                    vlTOPp->MESI__DOT__MESI_RAM_wr 
                        = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__28__write;
                    vlTOPp->MESI__DOT__MESI_RAM_wr_addr 
                        = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__28__write_addr;
                    vlTOPp->MESI__DOT__MESI_RAM_wr_data = 0U;
                    vlTOPp->err = 0U;
                    vlTOPp->mesi = 0U;
                    vlTOPp->index = (0x3fU & (vlTOPp->addr 
                                              >> 2U));
                    vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__27__Vfuncout 
                        = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__27__write;
                    vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__28__Vfuncout 
                        = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__28__write;
                    vlTOPp->TAG_RAM_status = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__27__Vfuncout;
                    vlTOPp->MESI_RAM_status = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__28__Vfuncout;
                } else {
                    ++(vlSymsp->__Vcoverage[188]);
                }
                if (((IData)(vlTOPp->MESI__DOT__WRITE) 
                     & (IData)(vlTOPp->MESI__DOT__TAG_MATCH))) {
                    vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__29__write_addr 
                        = (0x3fU & (vlTOPp->addr >> 2U));
                    vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__29__write 
                        = vlTOPp->MESI__DOT__TAG_WRITE;
                    ++(vlSymsp->__Vcoverage[212]);
                    vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__30__write_addr 
                        = (0x3fU & (vlTOPp->addr >> 2U));
                    vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__30__write 
                        = vlTOPp->MESI__DOT__MESI_WRITE;
                    ++(vlSymsp->__Vcoverage[210]);
                    ++(vlSymsp->__Vcoverage[189]);
                    vlTOPp->MESI__DOT__NEXT_STATE = 2U;
                    vlTOPp->MESI__DOT__TAG_RAM_wr = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__29__write;
                    vlTOPp->MESI__DOT__TAG_RAM_wr_addr 
                        = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__29__write_addr;
                    vlTOPp->MESI__DOT__TAG_RAM_wr_data = 0U;
                    vlTOPp->MESI__DOT__MESI_RAM_wr 
                        = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__30__write;
                    vlTOPp->MESI__DOT__MESI_RAM_wr_addr 
                        = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__30__write_addr;
                    vlTOPp->MESI__DOT__MESI_RAM_wr_data = 8U;
                    vlTOPp->err = 0U;
                    vlTOPp->mesi = 8U;
                    vlTOPp->index = (0x3fU & (vlTOPp->addr 
                                              >> 2U));
                    vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__29__Vfuncout 
                        = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__29__write;
                    vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__30__Vfuncout 
                        = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__30__write;
                    vlTOPp->TAG_RAM_status = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__29__Vfuncout;
                    vlTOPp->MESI_RAM_status = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__30__Vfuncout;
                } else {
                    ++(vlSymsp->__Vcoverage[190]);
                }
                if (((IData)(vlTOPp->MESI__DOT__WRITE) 
                     & (~ (IData)(vlTOPp->MESI__DOT__TAG_MATCH)))) {
                    vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__31__write_addr 
                        = (0x3fU & (vlTOPp->addr >> 2U));
                    vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__31__write 
                        = vlTOPp->MESI__DOT__TAG_WRITE;
                    ++(vlSymsp->__Vcoverage[212]);
                    vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__32__write_addr 
                        = (0x3fU & (vlTOPp->addr >> 2U));
                    vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__32__write 
                        = vlTOPp->MESI__DOT__MESI_WRITE;
                    ++(vlSymsp->__Vcoverage[210]);
                    ++(vlSymsp->__Vcoverage[191]);
                    vlTOPp->MESI__DOT__NEXT_STATE = 0U;
                    vlTOPp->MESI__DOT__TAG_RAM_wr = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__31__write;
                    vlTOPp->MESI__DOT__TAG_RAM_wr_addr 
                        = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__31__write_addr;
                    vlTOPp->MESI__DOT__TAG_RAM_wr_data = 0U;
                    vlTOPp->MESI__DOT__MESI_RAM_wr 
                        = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__32__write;
                    vlTOPp->MESI__DOT__MESI_RAM_wr_addr 
                        = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__32__write_addr;
                    vlTOPp->MESI__DOT__MESI_RAM_wr_data = 0U;
                    vlTOPp->err = 1U;
                    vlTOPp->mesi = 0U;
                    vlTOPp->index = (0x3fU & (vlTOPp->addr 
                                              >> 2U));
                    vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__31__Vfuncout 
                        = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__31__write;
                    vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__32__Vfuncout 
                        = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__32__write;
                    vlTOPp->TAG_RAM_status = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__31__Vfuncout;
                    vlTOPp->MESI_RAM_status = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__32__Vfuncout;
                } else {
                    ++(vlSymsp->__Vcoverage[192]);
                }
            } else {
                if ((5U == (IData)(vlTOPp->MESI__DOT__STATE))) {
                    ++(vlSymsp->__Vcoverage[200]);
                    if (vlTOPp->MESI__DOT__IDLE) {
                        vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__33__write_addr 
                            = (0x3fU & (vlTOPp->addr 
                                        >> 2U));
                        vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__33__write 
                            = vlTOPp->MESI__DOT__TAG_WRITE;
                        ++(vlSymsp->__Vcoverage[212]);
                        vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__34__write_addr 
                            = (0x3fU & (vlTOPp->addr 
                                        >> 2U));
                        vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__34__write 
                            = vlTOPp->MESI__DOT__MESI_WRITE;
                        ++(vlSymsp->__Vcoverage[210]);
                        ++(vlSymsp->__Vcoverage[194]);
                        vlTOPp->MESI__DOT__NEXT_STATE = 0U;
                        vlTOPp->MESI__DOT__TAG_RAM_wr 
                            = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__33__write;
                        vlTOPp->MESI__DOT__TAG_RAM_wr_addr 
                            = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__33__write_addr;
                        vlTOPp->MESI__DOT__TAG_RAM_wr_data = 0U;
                        vlTOPp->MESI__DOT__MESI_RAM_wr 
                            = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__34__write;
                        vlTOPp->MESI__DOT__MESI_RAM_wr_addr 
                            = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__34__write_addr;
                        vlTOPp->MESI__DOT__MESI_RAM_wr_data = 0U;
                        vlTOPp->err = 0U;
                        vlTOPp->mesi = 0U;
                        vlTOPp->index = (0x3fU & (vlTOPp->addr 
                                                  >> 2U));
                        vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__33__Vfuncout 
                            = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__33__write;
                        vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__34__Vfuncout 
                            = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__34__write;
                        vlTOPp->TAG_RAM_status = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__33__Vfuncout;
                        vlTOPp->MESI_RAM_status = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__34__Vfuncout;
                    } else {
                        ++(vlSymsp->__Vcoverage[195]);
                    }
                    if (((IData)(vlTOPp->MESI__DOT__rREAD) 
                         & (IData)(vlTOPp->MESI__DOT__TAG_MATCH))) {
                        vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__35__write_addr 
                            = (0x3fU & (vlTOPp->addr 
                                        >> 2U));
                        vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__35__write 
                            = vlTOPp->MESI__DOT__TAG_WRITE;
                        ++(vlSymsp->__Vcoverage[212]);
                        vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__36__write_addr 
                            = (0x3fU & (vlTOPp->addr 
                                        >> 2U));
                        vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__36__write 
                            = vlTOPp->MESI__DOT__MESI_WRITE;
                        ++(vlSymsp->__Vcoverage[210]);
                        ++(vlSymsp->__Vcoverage[196]);
                        vlTOPp->MESI__DOT__NEXT_STATE = 5U;
                        vlTOPp->MESI__DOT__TAG_RAM_wr 
                            = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__35__write;
                        vlTOPp->MESI__DOT__TAG_RAM_wr_addr 
                            = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__35__write_addr;
                        vlTOPp->MESI__DOT__TAG_RAM_wr_data = 0U;
                        vlTOPp->MESI__DOT__MESI_RAM_wr 
                            = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__36__write;
                        vlTOPp->MESI__DOT__MESI_RAM_wr_addr 
                            = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__36__write_addr;
                        vlTOPp->MESI__DOT__MESI_RAM_wr_data = 2U;
                        vlTOPp->err = 0U;
                        vlTOPp->mesi = 2U;
                        vlTOPp->index = (0x3fU & (vlTOPp->addr 
                                                  >> 2U));
                        vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__35__Vfuncout 
                            = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__35__write;
                        vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__36__Vfuncout 
                            = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__36__write;
                        vlTOPp->TAG_RAM_status = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__35__Vfuncout;
                        vlTOPp->MESI_RAM_status = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__36__Vfuncout;
                    } else {
                        ++(vlSymsp->__Vcoverage[197]);
                    }
                    if (((IData)(vlTOPp->MESI__DOT__rREAD) 
                         & (~ (IData)(vlTOPp->MESI__DOT__TAG_MATCH)))) {
                        vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__37__write_data 
                            = (0xffffffU & (vlTOPp->addr 
                                            >> 8U));
                        vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__37__write_addr 
                            = (0x3fU & (vlTOPp->addr 
                                        >> 2U));
                        vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__37__write 
                            = vlTOPp->MESI__DOT__TAG_WRITE;
                        ++(vlSymsp->__Vcoverage[212]);
                        vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__38__write_addr 
                            = (0x3fU & (vlTOPp->addr 
                                        >> 2U));
                        vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__38__write 
                            = vlTOPp->MESI__DOT__MESI_WRITE;
                        ++(vlSymsp->__Vcoverage[210]);
                        ++(vlSymsp->__Vcoverage[198]);
                        vlTOPp->MESI__DOT__NEXT_STATE = 5U;
                        vlTOPp->MESI__DOT__TAG_RAM_wr 
                            = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__37__write;
                        vlTOPp->MESI__DOT__TAG_RAM_wr_addr 
                            = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__37__write_addr;
                        vlTOPp->MESI__DOT__TAG_RAM_wr_data 
                            = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__37__write_data;
                        vlTOPp->MESI__DOT__MESI_RAM_wr 
                            = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__38__write;
                        vlTOPp->MESI__DOT__MESI_RAM_wr_addr 
                            = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__38__write_addr;
                        vlTOPp->MESI__DOT__MESI_RAM_wr_data = 2U;
                        vlTOPp->err = 0U;
                        vlTOPp->mesi = 2U;
                        vlTOPp->index = (0x3fU & (vlTOPp->addr 
                                                  >> 2U));
                        vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__37__Vfuncout 
                            = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__37__write;
                        vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__38__Vfuncout 
                            = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__38__write;
                        vlTOPp->TAG_RAM_status = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__37__Vfuncout;
                        vlTOPp->MESI_RAM_status = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__38__Vfuncout;
                    } else {
                        ++(vlSymsp->__Vcoverage[199]);
                    }
                } else {
                    if ((6U == (IData)(vlTOPp->MESI__DOT__STATE))) {
                        ++(vlSymsp->__Vcoverage[207]);
                        if (vlTOPp->MESI__DOT__IDLE) {
                            vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__39__write_addr 
                                = (0x3fU & (vlTOPp->addr 
                                            >> 2U));
                            vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__39__write 
                                = vlTOPp->MESI__DOT__TAG_WRITE;
                            ++(vlSymsp->__Vcoverage[212]);
                            vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__40__write_addr 
                                = (0x3fU & (vlTOPp->addr 
                                            >> 2U));
                            vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__40__write 
                                = vlTOPp->MESI__DOT__MESI_WRITE;
                            ++(vlSymsp->__Vcoverage[210]);
                            ++(vlSymsp->__Vcoverage[201]);
                            vlTOPp->MESI__DOT__NEXT_STATE = 0U;
                            vlTOPp->MESI__DOT__TAG_RAM_wr 
                                = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__39__write;
                            vlTOPp->MESI__DOT__TAG_RAM_wr_addr 
                                = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__39__write_addr;
                            vlTOPp->MESI__DOT__TAG_RAM_wr_data = 0U;
                            vlTOPp->MESI__DOT__MESI_RAM_wr 
                                = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__40__write;
                            vlTOPp->MESI__DOT__MESI_RAM_wr_addr 
                                = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__40__write_addr;
                            vlTOPp->MESI__DOT__MESI_RAM_wr_data = 0U;
                            vlTOPp->err = 0U;
                            vlTOPp->mesi = 0U;
                            vlTOPp->index = (0x3fU 
                                             & (vlTOPp->addr 
                                                >> 2U));
                            vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__39__Vfuncout 
                                = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__39__write;
                            vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__40__Vfuncout 
                                = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__40__write;
                            vlTOPp->TAG_RAM_status 
                                = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__39__Vfuncout;
                            vlTOPp->MESI_RAM_status 
                                = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__40__Vfuncout;
                        } else {
                            ++(vlSymsp->__Vcoverage[202]);
                        }
                        if (((IData)(vlTOPp->MESI__DOT__rWRITE) 
                             & (IData)(vlTOPp->MESI__DOT__TAG_MATCH))) {
                            vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__41__write_addr 
                                = (0x3fU & (vlTOPp->addr 
                                            >> 2U));
                            vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__41__write 
                                = vlTOPp->MESI__DOT__TAG_WRITE;
                            ++(vlSymsp->__Vcoverage[212]);
                            vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__42__write_addr 
                                = (0x3fU & (vlTOPp->addr 
                                            >> 2U));
                            vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__42__write 
                                = vlTOPp->MESI__DOT__MESI_WRITE;
                            ++(vlSymsp->__Vcoverage[210]);
                            ++(vlSymsp->__Vcoverage[203]);
                            vlTOPp->MESI__DOT__NEXT_STATE = 6U;
                            vlTOPp->MESI__DOT__TAG_RAM_wr 
                                = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__41__write;
                            vlTOPp->MESI__DOT__TAG_RAM_wr_addr 
                                = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__41__write_addr;
                            vlTOPp->MESI__DOT__TAG_RAM_wr_data = 0U;
                            vlTOPp->MESI__DOT__MESI_RAM_wr 
                                = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__42__write;
                            vlTOPp->MESI__DOT__MESI_RAM_wr_addr 
                                = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__42__write_addr;
                            vlTOPp->MESI__DOT__MESI_RAM_wr_data = 1U;
                            vlTOPp->err = 0U;
                            vlTOPp->mesi = 1U;
                            vlTOPp->index = (0x3fU 
                                             & (vlTOPp->addr 
                                                >> 2U));
                            vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__41__Vfuncout 
                                = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__41__write;
                            vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__42__Vfuncout 
                                = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__42__write;
                            vlTOPp->TAG_RAM_status 
                                = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__41__Vfuncout;
                            vlTOPp->MESI_RAM_status 
                                = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__42__Vfuncout;
                        } else {
                            ++(vlSymsp->__Vcoverage[204]);
                        }
                        if (((IData)(vlTOPp->MESI__DOT__rWRITE) 
                             & (~ (IData)(vlTOPp->MESI__DOT__TAG_MATCH)))) {
                            vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__43__write_addr 
                                = (0x3fU & (vlTOPp->addr 
                                            >> 2U));
                            vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__43__write 
                                = vlTOPp->MESI__DOT__TAG_WRITE;
                            ++(vlSymsp->__Vcoverage[212]);
                            vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__44__write_addr 
                                = (0x3fU & (vlTOPp->addr 
                                            >> 2U));
                            vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__44__write 
                                = vlTOPp->MESI__DOT__MESI_WRITE;
                            ++(vlSymsp->__Vcoverage[210]);
                            ++(vlSymsp->__Vcoverage[205]);
                            vlTOPp->MESI__DOT__NEXT_STATE = 6U;
                            vlTOPp->MESI__DOT__TAG_RAM_wr 
                                = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__43__write;
                            vlTOPp->MESI__DOT__TAG_RAM_wr_addr 
                                = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__43__write_addr;
                            vlTOPp->MESI__DOT__TAG_RAM_wr_data = 0U;
                            vlTOPp->MESI__DOT__MESI_RAM_wr 
                                = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__44__write;
                            vlTOPp->MESI__DOT__MESI_RAM_wr_addr 
                                = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__44__write_addr;
                            vlTOPp->MESI__DOT__MESI_RAM_wr_data = 0U;
                            vlTOPp->err = 0U;
                            vlTOPp->mesi = 0U;
                            vlTOPp->index = (0x3fU 
                                             & (vlTOPp->addr 
                                                >> 2U));
                            vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__43__Vfuncout 
                                = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__43__write;
                            vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__44__Vfuncout 
                                = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__44__write;
                            vlTOPp->TAG_RAM_status 
                                = vlTOPp->__Vfunc_MESI__DOT__WRITE_TAG_RAM__43__Vfuncout;
                            vlTOPp->MESI_RAM_status 
                                = vlTOPp->__Vfunc_MESI__DOT__WRITE_MESI_RAM__44__Vfuncout;
                        } else {
                            ++(vlSymsp->__Vcoverage[206]);
                        }
                    }
                }
            }
        }
    }
    if (VL_UNLIKELY((1U & (~ VL_ONEHOT_I((((6U == (IData)(vlTOPp->MESI__DOT__STATE)) 
                                           << 4U) | 
                                          (((5U == (IData)(vlTOPp->MESI__DOT__STATE)) 
                                            << 3U) 
                                           | (((2U 
                                                == (IData)(vlTOPp->MESI__DOT__STATE)) 
                                               << 2U) 
                                              | (((1U 
                                                   == (IData)(vlTOPp->MESI__DOT__STATE)) 
                                                  << 1U) 
                                                 | (0U 
                                                    == (IData)(vlTOPp->MESI__DOT__STATE))))))))))) {
        if (VL_UNLIKELY(Verilated::assertOn())) {
            VL_WRITEF("[%0t] %%Error: MESI.sv:158: Assertion failed in %NMESI: synthesis parallel_case, but multiple matches found\n",
                      64,VL_TIME_UNITED_Q(1),vlSymsp->name());
            VL_STOP_MT("MESI.sv", 158, "");
        }
    }
    if (((IData)(vlTOPp->err) ^ vlTOPp->MESI__DOT____Vtogcov__err)) {
        ++(vlSymsp->__Vcoverage[47]);
        vlTOPp->MESI__DOT____Vtogcov__err = vlTOPp->err;
    }
    if (((IData)(vlTOPp->TAG_RAM_status) ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_status)) {
        ++(vlSymsp->__Vcoverage[48]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_status 
            = vlTOPp->TAG_RAM_status;
    }
    if (((IData)(vlTOPp->MESI_RAM_status) ^ vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_status)) {
        ++(vlSymsp->__Vcoverage[49]);
        vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_status 
            = vlTOPp->MESI_RAM_status;
    }
    if (((IData)(vlTOPp->MESI__DOT__TAG_RAM_wr) ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr)) {
        ++(vlSymsp->__Vcoverage[78]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr = vlTOPp->MESI__DOT__TAG_RAM_wr;
    }
    if (((IData)(vlTOPp->MESI__DOT__MESI_RAM_wr) ^ vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_wr)) {
        ++(vlSymsp->__Vcoverage[56]);
        vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_wr = vlTOPp->MESI__DOT__MESI_RAM_wr;
    }
    if ((1U & ((IData)(vlTOPp->MESI__DOT__NEXT_STATE) 
               ^ vlTOPp->MESI__DOT____Vtogcov__NEXT_STATE))) {
        ++(vlSymsp->__Vcoverage[53]);
        vlTOPp->MESI__DOT____Vtogcov__NEXT_STATE = 
            ((6U & (IData)(vlTOPp->MESI__DOT____Vtogcov__NEXT_STATE)) 
             | (1U & (IData)(vlTOPp->MESI__DOT__NEXT_STATE)));
    }
    if ((2U & ((IData)(vlTOPp->MESI__DOT__NEXT_STATE) 
               ^ vlTOPp->MESI__DOT____Vtogcov__NEXT_STATE))) {
        ++(vlSymsp->__Vcoverage[54]);
        vlTOPp->MESI__DOT____Vtogcov__NEXT_STATE = 
            ((5U & (IData)(vlTOPp->MESI__DOT____Vtogcov__NEXT_STATE)) 
             | (2U & (IData)(vlTOPp->MESI__DOT__NEXT_STATE)));
    }
    if ((4U & ((IData)(vlTOPp->MESI__DOT__NEXT_STATE) 
               ^ vlTOPp->MESI__DOT____Vtogcov__NEXT_STATE))) {
        ++(vlSymsp->__Vcoverage[55]);
        vlTOPp->MESI__DOT____Vtogcov__NEXT_STATE = 
            ((3U & (IData)(vlTOPp->MESI__DOT____Vtogcov__NEXT_STATE)) 
             | (4U & (IData)(vlTOPp->MESI__DOT__NEXT_STATE)));
    }
    if ((1U & ((IData)(vlTOPp->mesi) ^ vlTOPp->MESI__DOT____Vtogcov__mesi))) {
        ++(vlSymsp->__Vcoverage[37]);
        vlTOPp->MESI__DOT____Vtogcov__mesi = ((0xeU 
                                               & (IData)(vlTOPp->MESI__DOT____Vtogcov__mesi)) 
                                              | (1U 
                                                 & (IData)(vlTOPp->mesi)));
    }
    if ((2U & ((IData)(vlTOPp->mesi) ^ vlTOPp->MESI__DOT____Vtogcov__mesi))) {
        ++(vlSymsp->__Vcoverage[38]);
        vlTOPp->MESI__DOT____Vtogcov__mesi = ((0xdU 
                                               & (IData)(vlTOPp->MESI__DOT____Vtogcov__mesi)) 
                                              | (2U 
                                                 & (IData)(vlTOPp->mesi)));
    }
    if ((4U & ((IData)(vlTOPp->mesi) ^ vlTOPp->MESI__DOT____Vtogcov__mesi))) {
        ++(vlSymsp->__Vcoverage[39]);
        vlTOPp->MESI__DOT____Vtogcov__mesi = ((0xbU 
                                               & (IData)(vlTOPp->MESI__DOT____Vtogcov__mesi)) 
                                              | (4U 
                                                 & (IData)(vlTOPp->mesi)));
    }
    if ((8U & ((IData)(vlTOPp->mesi) ^ vlTOPp->MESI__DOT____Vtogcov__mesi))) {
        ++(vlSymsp->__Vcoverage[40]);
        vlTOPp->MESI__DOT____Vtogcov__mesi = ((7U & (IData)(vlTOPp->MESI__DOT____Vtogcov__mesi)) 
                                              | (8U 
                                                 & (IData)(vlTOPp->mesi)));
    }
    if ((1U & ((IData)(vlTOPp->MESI__DOT__MESI_RAM_wr_data) 
               ^ vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_wr_data))) {
        ++(vlSymsp->__Vcoverage[63]);
        vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_wr_data 
            = ((0xeU & (IData)(vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_wr_data)) 
               | (1U & (IData)(vlTOPp->MESI__DOT__MESI_RAM_wr_data)));
    }
    if ((2U & ((IData)(vlTOPp->MESI__DOT__MESI_RAM_wr_data) 
               ^ vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_wr_data))) {
        ++(vlSymsp->__Vcoverage[64]);
        vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_wr_data 
            = ((0xdU & (IData)(vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_wr_data)) 
               | (2U & (IData)(vlTOPp->MESI__DOT__MESI_RAM_wr_data)));
    }
    if ((4U & ((IData)(vlTOPp->MESI__DOT__MESI_RAM_wr_data) 
               ^ vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_wr_data))) {
        ++(vlSymsp->__Vcoverage[65]);
        vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_wr_data 
            = ((0xbU & (IData)(vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_wr_data)) 
               | (4U & (IData)(vlTOPp->MESI__DOT__MESI_RAM_wr_data)));
    }
    if ((8U & ((IData)(vlTOPp->MESI__DOT__MESI_RAM_wr_data) 
               ^ vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_wr_data))) {
        ++(vlSymsp->__Vcoverage[66]);
        vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_wr_data 
            = ((7U & (IData)(vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_wr_data)) 
               | (8U & (IData)(vlTOPp->MESI__DOT__MESI_RAM_wr_data)));
    }
    if ((1U & ((IData)(vlTOPp->index) ^ vlTOPp->MESI__DOT____Vtogcov__index))) {
        ++(vlSymsp->__Vcoverage[41]);
        vlTOPp->MESI__DOT____Vtogcov__index = ((0x3eU 
                                                & (IData)(vlTOPp->MESI__DOT____Vtogcov__index)) 
                                               | (1U 
                                                  & (IData)(vlTOPp->index)));
    }
    if ((2U & ((IData)(vlTOPp->index) ^ vlTOPp->MESI__DOT____Vtogcov__index))) {
        ++(vlSymsp->__Vcoverage[42]);
        vlTOPp->MESI__DOT____Vtogcov__index = ((0x3dU 
                                                & (IData)(vlTOPp->MESI__DOT____Vtogcov__index)) 
                                               | (2U 
                                                  & (IData)(vlTOPp->index)));
    }
    if ((4U & ((IData)(vlTOPp->index) ^ vlTOPp->MESI__DOT____Vtogcov__index))) {
        ++(vlSymsp->__Vcoverage[43]);
        vlTOPp->MESI__DOT____Vtogcov__index = ((0x3bU 
                                                & (IData)(vlTOPp->MESI__DOT____Vtogcov__index)) 
                                               | (4U 
                                                  & (IData)(vlTOPp->index)));
    }
    if ((8U & ((IData)(vlTOPp->index) ^ vlTOPp->MESI__DOT____Vtogcov__index))) {
        ++(vlSymsp->__Vcoverage[44]);
        vlTOPp->MESI__DOT____Vtogcov__index = ((0x37U 
                                                & (IData)(vlTOPp->MESI__DOT____Vtogcov__index)) 
                                               | (8U 
                                                  & (IData)(vlTOPp->index)));
    }
    if ((0x10U & ((IData)(vlTOPp->index) ^ vlTOPp->MESI__DOT____Vtogcov__index))) {
        ++(vlSymsp->__Vcoverage[45]);
        vlTOPp->MESI__DOT____Vtogcov__index = ((0x2fU 
                                                & (IData)(vlTOPp->MESI__DOT____Vtogcov__index)) 
                                               | (0x10U 
                                                  & (IData)(vlTOPp->index)));
    }
    if ((0x20U & ((IData)(vlTOPp->index) ^ vlTOPp->MESI__DOT____Vtogcov__index))) {
        ++(vlSymsp->__Vcoverage[46]);
        vlTOPp->MESI__DOT____Vtogcov__index = ((0x1fU 
                                                & (IData)(vlTOPp->MESI__DOT____Vtogcov__index)) 
                                               | (0x20U 
                                                  & (IData)(vlTOPp->index)));
    }
    if ((1U & ((IData)(vlTOPp->MESI__DOT__TAG_RAM_wr_addr) 
               ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_addr))) {
        ++(vlSymsp->__Vcoverage[79]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_addr 
            = ((0x3eU & (IData)(vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_addr)) 
               | (1U & (IData)(vlTOPp->MESI__DOT__TAG_RAM_wr_addr)));
    }
    if ((2U & ((IData)(vlTOPp->MESI__DOT__TAG_RAM_wr_addr) 
               ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_addr))) {
        ++(vlSymsp->__Vcoverage[80]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_addr 
            = ((0x3dU & (IData)(vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_addr)) 
               | (2U & (IData)(vlTOPp->MESI__DOT__TAG_RAM_wr_addr)));
    }
    if ((4U & ((IData)(vlTOPp->MESI__DOT__TAG_RAM_wr_addr) 
               ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_addr))) {
        ++(vlSymsp->__Vcoverage[81]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_addr 
            = ((0x3bU & (IData)(vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_addr)) 
               | (4U & (IData)(vlTOPp->MESI__DOT__TAG_RAM_wr_addr)));
    }
    if ((8U & ((IData)(vlTOPp->MESI__DOT__TAG_RAM_wr_addr) 
               ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_addr))) {
        ++(vlSymsp->__Vcoverage[82]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_addr 
            = ((0x37U & (IData)(vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_addr)) 
               | (8U & (IData)(vlTOPp->MESI__DOT__TAG_RAM_wr_addr)));
    }
    if ((0x10U & ((IData)(vlTOPp->MESI__DOT__TAG_RAM_wr_addr) 
                  ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_addr))) {
        ++(vlSymsp->__Vcoverage[83]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_addr 
            = ((0x2fU & (IData)(vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_addr)) 
               | (0x10U & (IData)(vlTOPp->MESI__DOT__TAG_RAM_wr_addr)));
    }
    if ((0x20U & ((IData)(vlTOPp->MESI__DOT__TAG_RAM_wr_addr) 
                  ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_addr))) {
        ++(vlSymsp->__Vcoverage[84]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_addr 
            = ((0x1fU & (IData)(vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_addr)) 
               | (0x20U & (IData)(vlTOPp->MESI__DOT__TAG_RAM_wr_addr)));
    }
    if ((1U & ((IData)(vlTOPp->MESI__DOT__MESI_RAM_wr_addr) 
               ^ vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_wr_addr))) {
        ++(vlSymsp->__Vcoverage[57]);
        vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_wr_addr 
            = ((0x3eU & (IData)(vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_wr_addr)) 
               | (1U & (IData)(vlTOPp->MESI__DOT__MESI_RAM_wr_addr)));
    }
    if ((2U & ((IData)(vlTOPp->MESI__DOT__MESI_RAM_wr_addr) 
               ^ vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_wr_addr))) {
        ++(vlSymsp->__Vcoverage[58]);
        vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_wr_addr 
            = ((0x3dU & (IData)(vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_wr_addr)) 
               | (2U & (IData)(vlTOPp->MESI__DOT__MESI_RAM_wr_addr)));
    }
    if ((4U & ((IData)(vlTOPp->MESI__DOT__MESI_RAM_wr_addr) 
               ^ vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_wr_addr))) {
        ++(vlSymsp->__Vcoverage[59]);
        vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_wr_addr 
            = ((0x3bU & (IData)(vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_wr_addr)) 
               | (4U & (IData)(vlTOPp->MESI__DOT__MESI_RAM_wr_addr)));
    }
    if ((8U & ((IData)(vlTOPp->MESI__DOT__MESI_RAM_wr_addr) 
               ^ vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_wr_addr))) {
        ++(vlSymsp->__Vcoverage[60]);
        vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_wr_addr 
            = ((0x37U & (IData)(vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_wr_addr)) 
               | (8U & (IData)(vlTOPp->MESI__DOT__MESI_RAM_wr_addr)));
    }
    if ((0x10U & ((IData)(vlTOPp->MESI__DOT__MESI_RAM_wr_addr) 
                  ^ vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_wr_addr))) {
        ++(vlSymsp->__Vcoverage[61]);
        vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_wr_addr 
            = ((0x2fU & (IData)(vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_wr_addr)) 
               | (0x10U & (IData)(vlTOPp->MESI__DOT__MESI_RAM_wr_addr)));
    }
    if ((0x20U & ((IData)(vlTOPp->MESI__DOT__MESI_RAM_wr_addr) 
                  ^ vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_wr_addr))) {
        ++(vlSymsp->__Vcoverage[62]);
        vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_wr_addr 
            = ((0x1fU & (IData)(vlTOPp->MESI__DOT____Vtogcov__MESI_RAM_wr_addr)) 
               | (0x20U & (IData)(vlTOPp->MESI__DOT__MESI_RAM_wr_addr)));
    }
    if ((1U & (vlTOPp->MESI__DOT__TAG_RAM_wr_data ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data))) {
        ++(vlSymsp->__Vcoverage[85]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data 
            = ((0xfffffeU & vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data) 
               | (1U & vlTOPp->MESI__DOT__TAG_RAM_wr_data));
    }
    if ((2U & (vlTOPp->MESI__DOT__TAG_RAM_wr_data ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data))) {
        ++(vlSymsp->__Vcoverage[86]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data 
            = ((0xfffffdU & vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data) 
               | (2U & vlTOPp->MESI__DOT__TAG_RAM_wr_data));
    }
    if ((4U & (vlTOPp->MESI__DOT__TAG_RAM_wr_data ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data))) {
        ++(vlSymsp->__Vcoverage[87]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data 
            = ((0xfffffbU & vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data) 
               | (4U & vlTOPp->MESI__DOT__TAG_RAM_wr_data));
    }
    if ((8U & (vlTOPp->MESI__DOT__TAG_RAM_wr_data ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data))) {
        ++(vlSymsp->__Vcoverage[88]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data 
            = ((0xfffff7U & vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data) 
               | (8U & vlTOPp->MESI__DOT__TAG_RAM_wr_data));
    }
    if ((0x10U & (vlTOPp->MESI__DOT__TAG_RAM_wr_data 
                  ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data))) {
        ++(vlSymsp->__Vcoverage[89]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data 
            = ((0xffffefU & vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data) 
               | (0x10U & vlTOPp->MESI__DOT__TAG_RAM_wr_data));
    }
    if ((0x20U & (vlTOPp->MESI__DOT__TAG_RAM_wr_data 
                  ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data))) {
        ++(vlSymsp->__Vcoverage[90]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data 
            = ((0xffffdfU & vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data) 
               | (0x20U & vlTOPp->MESI__DOT__TAG_RAM_wr_data));
    }
    if ((0x40U & (vlTOPp->MESI__DOT__TAG_RAM_wr_data 
                  ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data))) {
        ++(vlSymsp->__Vcoverage[91]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data 
            = ((0xffffbfU & vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data) 
               | (0x40U & vlTOPp->MESI__DOT__TAG_RAM_wr_data));
    }
    if ((0x80U & (vlTOPp->MESI__DOT__TAG_RAM_wr_data 
                  ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data))) {
        ++(vlSymsp->__Vcoverage[92]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data 
            = ((0xffff7fU & vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data) 
               | (0x80U & vlTOPp->MESI__DOT__TAG_RAM_wr_data));
    }
    if ((0x100U & (vlTOPp->MESI__DOT__TAG_RAM_wr_data 
                   ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data))) {
        ++(vlSymsp->__Vcoverage[93]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data 
            = ((0xfffeffU & vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data) 
               | (0x100U & vlTOPp->MESI__DOT__TAG_RAM_wr_data));
    }
    if ((0x200U & (vlTOPp->MESI__DOT__TAG_RAM_wr_data 
                   ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data))) {
        ++(vlSymsp->__Vcoverage[94]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data 
            = ((0xfffdffU & vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data) 
               | (0x200U & vlTOPp->MESI__DOT__TAG_RAM_wr_data));
    }
    if ((0x400U & (vlTOPp->MESI__DOT__TAG_RAM_wr_data 
                   ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data))) {
        ++(vlSymsp->__Vcoverage[95]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data 
            = ((0xfffbffU & vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data) 
               | (0x400U & vlTOPp->MESI__DOT__TAG_RAM_wr_data));
    }
    if ((0x800U & (vlTOPp->MESI__DOT__TAG_RAM_wr_data 
                   ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data))) {
        ++(vlSymsp->__Vcoverage[96]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data 
            = ((0xfff7ffU & vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data) 
               | (0x800U & vlTOPp->MESI__DOT__TAG_RAM_wr_data));
    }
    if ((0x1000U & (vlTOPp->MESI__DOT__TAG_RAM_wr_data 
                    ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data))) {
        ++(vlSymsp->__Vcoverage[97]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data 
            = ((0xffefffU & vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data) 
               | (0x1000U & vlTOPp->MESI__DOT__TAG_RAM_wr_data));
    }
    if ((0x2000U & (vlTOPp->MESI__DOT__TAG_RAM_wr_data 
                    ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data))) {
        ++(vlSymsp->__Vcoverage[98]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data 
            = ((0xffdfffU & vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data) 
               | (0x2000U & vlTOPp->MESI__DOT__TAG_RAM_wr_data));
    }
    if ((0x4000U & (vlTOPp->MESI__DOT__TAG_RAM_wr_data 
                    ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data))) {
        ++(vlSymsp->__Vcoverage[99]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data 
            = ((0xffbfffU & vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data) 
               | (0x4000U & vlTOPp->MESI__DOT__TAG_RAM_wr_data));
    }
    if ((0x8000U & (vlTOPp->MESI__DOT__TAG_RAM_wr_data 
                    ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data))) {
        ++(vlSymsp->__Vcoverage[100]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data 
            = ((0xff7fffU & vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data) 
               | (0x8000U & vlTOPp->MESI__DOT__TAG_RAM_wr_data));
    }
    if ((0x10000U & (vlTOPp->MESI__DOT__TAG_RAM_wr_data 
                     ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data))) {
        ++(vlSymsp->__Vcoverage[101]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data 
            = ((0xfeffffU & vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data) 
               | (0x10000U & vlTOPp->MESI__DOT__TAG_RAM_wr_data));
    }
    if ((0x20000U & (vlTOPp->MESI__DOT__TAG_RAM_wr_data 
                     ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data))) {
        ++(vlSymsp->__Vcoverage[102]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data 
            = ((0xfdffffU & vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data) 
               | (0x20000U & vlTOPp->MESI__DOT__TAG_RAM_wr_data));
    }
    if ((0x40000U & (vlTOPp->MESI__DOT__TAG_RAM_wr_data 
                     ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data))) {
        ++(vlSymsp->__Vcoverage[103]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data 
            = ((0xfbffffU & vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data) 
               | (0x40000U & vlTOPp->MESI__DOT__TAG_RAM_wr_data));
    }
    if ((0x80000U & (vlTOPp->MESI__DOT__TAG_RAM_wr_data 
                     ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data))) {
        ++(vlSymsp->__Vcoverage[104]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data 
            = ((0xf7ffffU & vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data) 
               | (0x80000U & vlTOPp->MESI__DOT__TAG_RAM_wr_data));
    }
    if ((0x100000U & (vlTOPp->MESI__DOT__TAG_RAM_wr_data 
                      ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data))) {
        ++(vlSymsp->__Vcoverage[105]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data 
            = ((0xefffffU & vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data) 
               | (0x100000U & vlTOPp->MESI__DOT__TAG_RAM_wr_data));
    }
    if ((0x200000U & (vlTOPp->MESI__DOT__TAG_RAM_wr_data 
                      ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data))) {
        ++(vlSymsp->__Vcoverage[106]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data 
            = ((0xdfffffU & vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data) 
               | (0x200000U & vlTOPp->MESI__DOT__TAG_RAM_wr_data));
    }
    if ((0x400000U & (vlTOPp->MESI__DOT__TAG_RAM_wr_data 
                      ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data))) {
        ++(vlSymsp->__Vcoverage[107]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data 
            = ((0xbfffffU & vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data) 
               | (0x400000U & vlTOPp->MESI__DOT__TAG_RAM_wr_data));
    }
    if ((0x800000U & (vlTOPp->MESI__DOT__TAG_RAM_wr_data 
                      ^ vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data))) {
        ++(vlSymsp->__Vcoverage[108]);
        vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data 
            = ((0x7fffffU & vlTOPp->MESI__DOT____Vtogcov__TAG_RAM_wr_data) 
               | (0x800000U & vlTOPp->MESI__DOT__TAG_RAM_wr_data));
    }
}

void VMESI::_eval(VMESI__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_DBG_MSGF("+    VMESI::_eval\n"); );
    VMESI* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    vlTOPp->_combo__TOP__1(vlSymsp);
    vlTOPp->__Vm_traceActivity[1U] = 1U;
    if (((IData)(vlTOPp->clk) & (~ (IData)(vlTOPp->__Vclklast__TOP__clk)))) {
        vlTOPp->_sequent__TOP__4(vlSymsp);
    }
    if ((((IData)(vlTOPp->clk) & (~ (IData)(vlTOPp->__Vclklast__TOP__clk))) 
         | ((~ (IData)(vlTOPp->res_n)) & (IData)(vlTOPp->__Vclklast__TOP__res_n)))) {
        vlTOPp->_sequent__TOP__5(vlSymsp);
    }
    vlTOPp->_combo__TOP__7(vlSymsp);
    // Final
    vlTOPp->__Vclklast__TOP__clk = vlTOPp->clk;
    vlTOPp->__Vclklast__TOP__res_n = vlTOPp->res_n;
}

VL_INLINE_OPT QData VMESI::_change_request(VMESI__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_DBG_MSGF("+    VMESI::_change_request\n"); );
    VMESI* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    return (vlTOPp->_change_request_1(vlSymsp));
}

VL_INLINE_OPT QData VMESI::_change_request_1(VMESI__Syms* __restrict vlSymsp) {
    VL_DEBUG_IF(VL_DBG_MSGF("+    VMESI::_change_request_1\n"); );
    VMESI* const __restrict vlTOPp VL_ATTR_UNUSED = vlSymsp->TOPp;
    // Body
    // Change detection
    QData __req = false;  // Logically a bool
    __req |= ((vlTOPp->MESI__DOT__MESI_RAM_rd_data ^ vlTOPp->__Vchglast__TOP__MESI__DOT__MESI_RAM_rd_data)
         | (vlTOPp->MESI__DOT__TAG_RAM_rd_data ^ vlTOPp->__Vchglast__TOP__MESI__DOT__TAG_RAM_rd_data));
    VL_DEBUG_IF( if(__req && ((vlTOPp->MESI__DOT__MESI_RAM_rd_data ^ vlTOPp->__Vchglast__TOP__MESI__DOT__MESI_RAM_rd_data))) VL_DBG_MSGF("        CHANGE: MESI.sv:64: MESI.MESI_RAM_rd_data\n"); );
    VL_DEBUG_IF( if(__req && ((vlTOPp->MESI__DOT__TAG_RAM_rd_data ^ vlTOPp->__Vchglast__TOP__MESI__DOT__TAG_RAM_rd_data))) VL_DBG_MSGF("        CHANGE: MESI.sv:78: MESI.TAG_RAM_rd_data\n"); );
    // Final
    vlTOPp->__Vchglast__TOP__MESI__DOT__MESI_RAM_rd_data 
        = vlTOPp->MESI__DOT__MESI_RAM_rd_data;
    vlTOPp->__Vchglast__TOP__MESI__DOT__TAG_RAM_rd_data 
        = vlTOPp->MESI__DOT__TAG_RAM_rd_data;
    return __req;
}

#ifdef VL_DEBUG
void VMESI::_eval_debug_assertions() {
    VL_DEBUG_IF(VL_DBG_MSGF("+    VMESI::_eval_debug_assertions\n"); );
    // Body
    if (VL_UNLIKELY((clk & 0xfeU))) {
        Verilated::overWidthError("clk");}
    if (VL_UNLIKELY((res_n & 0xfeU))) {
        Verilated::overWidthError("res_n");}
    if (VL_UNLIKELY((cp & 0xfeU))) {
        Verilated::overWidthError("cp");}
    if (VL_UNLIKELY((rd & 0xfeU))) {
        Verilated::overWidthError("rd");}
    if (VL_UNLIKELY((wr & 0xfeU))) {
        Verilated::overWidthError("wr");}
}
#endif  // VL_DEBUG
